﻿local EventFrame = CreateFrame("Frame", "EventsHeartFire")
local hfFrame
local m_Info
local epgp
local GS
local HF_ICON

local HeartFireConfig = {
	name = "Heart_Of_Fire",
	Addon = { },
	Frame = {},
	cbEnable,
	cbPosition,
	NumberSeperator = { },
	Seperator = {}
}

local Icons = {}
local logRefresh = true

local infoAddonText = {}

HeartFire = LibStub("AceAddon-3.0"):NewAddon(HeartFireConfig.name, "AceConsole-3.0", "AceEvent-3.0")
HeartFireConsole = LibStub("AceConsole-3.0")
CallbackHandler = LibStub("CallbackHandler-1.0")
if not HF_CallbackHandler then
	HF_CallbackHandler = CallbackHandler:New(HeartFire)
end



SlashCmdList['HFRUI'] = function() ReloadUI() end
SLASH_HFRUI1 = '/релоад'
SLASH_HFRUI2 = '/руи'
SLASH_HFRUI3 = '/перезагрузка'

EventFrame:RegisterEvent("ADDON_LOADED")
EventFrame:RegisterEvent("PLAYER_LOGOUT")
EventFrame:RegisterEvent("PLAYER_GUILD_UPDATE")
EventFrame:RegisterEvent("GUILD_ROSTER_UPDATE")
EventFrame:SetScript("OnEvent", function(self,event,...) 

	if (event == "ADDON_LOADED") then
		local addonName = ...	
		if addonName ~= HeartFireConfig.name then
			return
		end		
		
		hfFrame = LibStub:GetLibrary("LibFrame")
		m_Info = LibStub:GetLibrary("InfoGuild")
		epgp = LibStub:GetLibrary("EpGp")
		GS = LibStub:GetLibrary("LibGuildStorage")
		HF_ICON = LibStub:GetLibrary("IconConfig")
				
		HeartFire_OnLoad()

		HeartFireConfig.Frame = { 
			HF_Frame_Main, 
			HF_Frame_Buttons, 
			HF_Frame_NumberSeperator, 
			HF_Frame_IconConfig, 
			HF_Frame_EgGp,
			
			HF_control_Top_Left, 
			HF_control_Top_Right, 
			HF_control_EgGp
		}
						
		Load_MainFrame()		
		Load_Buttons()	
		HeartFireConfig = m_Info:Instaling(HeartFireConfig.Frame.HF_Frame_Main, HeartFireConfig, HeartFire)
		Load_NumberSeperator()		
		
		epgp:Load_SaveVariable()
		HeartFireConfig.Frame.HF_Frame_EgGp, HeartFireConfig.Frame.HF_control_EgGp = epgp:Load_EgGp(HeartFireConfig.Frame.HF_Frame_Main, HeartFire) 
		HF_ICON:Loading(HeartFireConfig.Frame.HF_Frame_Main)
						
		HF_ICON:Set_Icon()	
		
		HeartFireConfig.Frame.HF_Frame_Main:Hide()
		HeartFireConfig.Frame.HF_Frame_Buttons:Hide()
		HeartFireConfig.Frame.HF_Frame_NumberSeperator:Hide()
		HF_ICON:Hide()
		HeartFireConfig.Frame.HF_control_Top_Left:Hide()
		HeartFireConfig.Frame.HF_control_Top_Right:Hide()	
		epgp:Hide()
			
		self:UnregisterEvent("ADDON_LOADED")		
		return
	end
end)



local ep_data = {}
local gp_data = {}
local main_data = {}
local alt_data = {}
local ourRealmName = string.gsub(GetRealmName(), "%s+", "")   
  
function GetOurRealmName()
	return ourRealmName
end



function HeartFire_OnEvent(self,event,...)
--print("HeartFire_OnEvent")
end

function HeartFire_OnUpdate()
--print("HeartFire_OnUpdate")
end

function HeartFire:showoptions()
--print("showoptions")
end

function HeartFire:closeallpr()
--print("closeallpr")
end

function HeartFire:OnInitialize() 	
--print("OnInitialize")
end

function HeartFire:OnEnable()
--print("OnEnable")
end

function HeartFire:OnDisable()
--print("OnDisable")
end

function HeartFire:ConfigOpen()
	if (HF_Save_Data.ActiveFrame == nil) then 
		HF_Save_Data.ActiveFrame = false
	end			
	
	if (HF_Save_Data.clearFramePosition == true) then
		HeartFireConfig.Frame.HF_Frame_Main:ClearAllPoints() --  сброс позиционирования родителя фрэймов
		HeartFireConfig.Frame.HF_Frame_Main:SetPoint("CENTER")  
	end
	
	if (HF_Save_Data.ActiveFrame == false) then		
		HF_Save_Data.ActiveFrame = true
				
		HeartFireConfig.Frame.HF_Frame_Main:Show()
		HeartFireConfig.Frame.HF_Frame_Buttons:Show()
		HeartFireConfig.Frame.HF_control_Top_Left:Show()
		m_Info:Show()
	else
		HF_Save_Data.ActiveFrame = false
		HeartFireConfig.Frame.HF_Frame_Main:Hide()
		HeartFireConfig.Frame.HF_Frame_Buttons:Hide()
		HeartFireConfig.Frame.HF_Frame_NumberSeperator:Hide()
		HF_ICON:Hide()
		HeartFireConfig.Frame.HF_control_Top_Left:Hide()
		HeartFireConfig.Frame.HF_control_Top_Right:Hide()	
		epgp:Hide()
		m_Info:Hide()
	end
end

SlashCmdList['HF'] = function() HeartFire:ConfigOpen() end
SLASH_HF1 = '/hf'
SLASH_HF2 = '/heartfire'
SLASH_HF3 = '/со'
SLASH_HF4 = '/сердцеогня'
SLASH_HF5 = '/co'

function HeartFire:AddonInfo()
	HF_closeallpr()
end

function Load_MainFrame()
	HeartFireConfig.Frame.HF_Frame_Main = hfFrame:Get_MainFrame("HF_Frame_Main", 930, 460, "CENTER")
	HeartFireConfig.Frame.HF_control_Top_Left = hfFrame:Get_Frame("HF_control_Top_Left", HeartFireConfig.Frame.HF_Frame_Main, 180, 30, "TOPLEFT")
		
	HeartFireConfig.Frame.HF_control_Top_Right = hfFrame:Get_Frame("HF_control_Top_Right", HeartFireConfig.Frame.HF_Frame_Main, 750, 30, "TOPRIGHT")
end

function Load_Buttons()
	HeartFireConfig.Frame.HF_Frame_Buttons = hfFrame:Get_Frame("HF_Frame_Buttons", HeartFireConfig.Frame.HF_Frame_Main, 180, 400, "Left")
	
	local t = HeartFireConfig.Frame.HF_Frame_Buttons:CreateFontString()
	t:SetFont(GameFontNormal:GetFont(), 13)
	t:SetText("Сердце огня")
	t:SetPoint("TOP",0,20)
	
	local button = CreateFrame("Button", "btInfoAddon", HeartFireConfig.Frame.HF_Frame_Buttons)
	button:SetPoint("Top", HeartFireConfig.Frame.HF_Frame_Buttons, "Top", 0, -10)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("О гильдии")
	button:SetNormalFontObject("GameFontNormalSmall")	
	button:SetScript("OnMouseUp", SetFrame_InfoAddon)	
	
	button = hfFrame:Get_Texture_Button(button)
	
	local button = CreateFrame("Button", "btNumberSeperator", HeartFireConfig.Frame.HF_Frame_Buttons)
	button:SetPoint("Top", HeartFireConfig.Frame.HF_Frame_Buttons, "Top", 0, -30)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Разделитель чисел")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", SetFrame_NumberSeperator)	
	
	button = hfFrame:Get_Texture_Button(button)
	
	local button = CreateFrame("Button", "btEpGp", HeartFireConfig.Frame.HF_Frame_Buttons)
	button:SetPoint("Top", HeartFireConfig.Frame.HF_Frame_Buttons, "Top", 0, -50)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("EpGp")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", SetFrame_EpGp)	
	
	button = hfFrame:Get_Texture_Button(button)
	
	local button = CreateFrame("Button", "btConfigIcon", HeartFireConfig.Frame.HF_Frame_Buttons)
	button:SetPoint("Top", HeartFireConfig.Frame.HF_Frame_Buttons, "Top", 0, -350)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Настройки иконки")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", SetFrame_IconConfig)	
	
	button = hfFrame:Get_Texture_Button(button)
	
	local button = CreateFrame("Button", "btClose", HeartFireConfig.Frame.HF_Frame_Buttons)
	button:SetPoint("Top", HeartFireConfig.Frame.HF_Frame_Buttons, "Top", 0, -370)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Закрыть")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", function() HeartFire:ConfigOpen() end)	
	
	button = hfFrame:Get_Texture_Button(button)
end

function Load_NumberSeperator()
	HeartFireConfig.Frame.HF_Frame_NumberSeperator = hfFrame:Get_Frame("HF_Frame_NumberSeperator", HeartFireConfig.Frame.HF_Frame_Main, 750, 400, "Right")
			
	local tInfo = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateFontString()
	tInfo:SetFont(GameFontNormal:GetFont(), 13)
	tInfo:SetText("Разделитель чисел")
	tInfo:SetJustifyH("LEFT")
	tInfo:SetJustifyV("TOP")
	tInfo:SetPoint("TOPLEFT",20,20)
	
	HeartFireConfig.Seperator.Probel = CreateFrame("CheckButton", "cbSer1", HeartFireConfig.Frame.HF_Frame_NumberSeperator, "ChatConfigCheckButtonTemplate")
	HeartFireConfig.Seperator.Probel:SetPoint("TOPLEFT", 20, -10)
	HeartFireConfig.Seperator.Probel:SetScript("OnClick", function() HeartFireConfig.NumberSeperator.idSeperator = 1 HF_Seperator() end)	
	if (HeartFireConfig.NumberSeperator.idSeperator == 1) then
		HeartFireConfig.Seperator.Probel:SetChecked(true)
	else
		HeartFireConfig.Seperator.Probel:SetChecked(false)
	end
		
	local tcbProbel = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateFontString()
	tcbProbel:SetFont(GameFontNormal:GetFont(), 13)
	tcbProbel:SetText("Пробел")
	tcbProbel:SetJustifyH("LEFT")
	tcbProbel:SetJustifyV("TOP")
	tcbProbel:SetPoint("TOPLEFT",50,-15)
		
		
	HeartFireConfig.Seperator.TKCH = CreateFrame("CheckButton", "cbSer2", HeartFireConfig.Frame.HF_Frame_NumberSeperator, "ChatConfigCheckButtonTemplate")
	HeartFireConfig.Seperator.TKCH:SetPoint("TOPLEFT", 20, -35)
	HeartFireConfig.Seperator.TKCH:SetScript("OnClick", function() HeartFireConfig.NumberSeperator.idSeperator = 2 HF_Seperator() end)	
	if (HeartFireConfig.NumberSeperator.idSeperator == 2) then
		HeartFireConfig.Seperator.TKCH:SetChecked(true)
	else
		HeartFireConfig.Seperator.TKCH:SetChecked(false)
	end
	
	local tcbTKCH = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateFontString()
	tcbTKCH:SetFont(GameFontNormal:GetFont(), 13)
	tcbTKCH:SetText("Точка")
	tcbTKCH:SetJustifyH("LEFT")
	tcbTKCH:SetJustifyV("TOP")
	tcbTKCH:SetPoint("TOPLEFT",50,-40)
	
	
	HeartFireConfig.Seperator.Zapitai = CreateFrame("CheckButton", "cbSer3", HeartFireConfig.Frame.HF_Frame_NumberSeperator, "ChatConfigCheckButtonTemplate")
	HeartFireConfig.Seperator.Zapitai:SetPoint("TOPLEFT", 20, -60)
	HeartFireConfig.Seperator.Zapitai:SetScript("OnClick", function() HeartFireConfig.NumberSeperator.idSeperator = 3 HF_Seperator() end)	
	if (HeartFireConfig.NumberSeperator.idSeperator == 3) then
		HeartFireConfig.Seperator.Zapitai:SetChecked(true)
	else
		HeartFireConfig.Seperator.Zapitai:SetChecked(false)
	end
	
	local tcbZapitai = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateFontString()
	tcbZapitai:SetFont(GameFontNormal:GetFont(), 13)
	tcbZapitai:SetText("Запятая")
	tcbZapitai:SetJustifyH("LEFT")
	tcbZapitai:SetJustifyV("TOP")
	tcbZapitai:SetPoint("TOPLEFT",50,-65)
	
	
	HeartFireConfig.Seperator.Custom = CreateFrame("CheckButton", "cbSer0", HeartFireConfig.Frame.HF_Frame_NumberSeperator, "ChatConfigCheckButtonTemplate")
	HeartFireConfig.Seperator.Custom:SetPoint("TOPLEFT", 20, -85)
	HeartFireConfig.Seperator.Custom:SetScript("OnClick", function() HeartFireConfig.NumberSeperator.idSeperator = 0 HF_Seperator() end)	
	if (HeartFireConfig.NumberSeperator.idSeperator == 0) then
		HeartFireConfig.Seperator.Custom:SetChecked(true)
	else
		HeartFireConfig.Seperator.Custom:SetChecked(false)
	end
	
	local tcbCustom = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateFontString()
	tcbCustom:SetFont(GameFontNormal:GetFont(), 13)
	tcbCustom:SetText("Свой разделитель")
	tcbCustom:SetJustifyH("LEFT")
	tcbCustom:SetJustifyV("TOP")
	tcbCustom:SetPoint("TOPLEFT",50,-90)
	
	HeartFireConfig.Seperator.CustomED = CreateFrame("EditBox", "edCustom", HeartFireConfig.Frame.HF_Frame_NumberSeperator, "InputBoxTemplate")
	HeartFireConfig.Seperator.CustomED:SetPoint("TOPLEFT",180,-85)	
	HeartFireConfig.Seperator.CustomED:SetWidth(150)
	HeartFireConfig.Seperator.CustomED:SetHeight(21)
	HeartFireConfig.Seperator.CustomED:SetScript("OnTextChanged", function() if ( HeartFireConfig.NumberSeperator.idSeperator == 0) then HF_Seperator() end end)
	if (HeartFireConfig.NumberSeperator.idSeperator == 0) then
		HeartFireConfig.Seperator.CustomED:SetText(HeartFireConfig.NumberSeperator.customSeperator)
		HeartFireConfig.Seperator.CustomED:Enable()		
	else
		HeartFireConfig.Seperator.CustomED:Disable()
	end
	
	crMapBackground = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateTexture(nil,"BORDER")
	crMapBackground:SetTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\NumberSeperator\\t01_d.tga")
	crMapBackground:SetPoint("TOPLEFT",10,-150)
	crMapBackground:SetSize(256, 128)
	
	crMapBackground = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateTexture(nil,"BORDER")
	crMapBackground:SetTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\NumberSeperator\\t.tga")
	crMapBackground:SetPoint("TOPLEFT",270,-194)
	crMapBackground:SetSize(64, 32)
	
	crMapBackground = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateTexture(nil,"BORDER")
	crMapBackground:SetTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\NumberSeperator\\t01_e.tga")
	crMapBackground:SetPoint("TOPLEFT",340,-150)
	crMapBackground:SetSize(256, 128)
	
	
	crMapBackground = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateTexture(nil,"BORDER")
	crMapBackground:SetTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\NumberSeperator\\t02_d.tga")
	crMapBackground:SetPoint("TOPLEFT",340,-10)
	crMapBackground:SetSize(256, 64)	
	
	crMapBackground = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateTexture(nil,"BORDER")
	crMapBackground:SetTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\NumberSeperator\\t02_e.tga")
	crMapBackground:SetPoint("TOPLEFT",460,-80)
	crMapBackground:SetSize(256, 64)
	
	
	crMapBackground = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateTexture(nil,"BORDER")
	crMapBackground:SetTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\NumberSeperator\\t03_d.tga")
	crMapBackground:SetPoint("TOPLEFT",10,-310)
	crMapBackground:SetSize(128, 64)
	
	crMapBackground = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateTexture(nil,"BORDER")
	crMapBackground:SetTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\NumberSeperator\\t.tga")
	crMapBackground:SetPoint("TOPLEFT",145,-324)
	crMapBackground:SetSize(64, 32)
	
	crMapBackground = HeartFireConfig.Frame.HF_Frame_NumberSeperator:CreateTexture(nil,"BORDER")
	crMapBackground:SetTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\NumberSeperator\\t03_e.tga")
	crMapBackground:SetPoint("TOPLEFT",210,-310)
	crMapBackground:SetSize(128, 64)
end

function SetFrame_InfoAddon()
	m_Info:Clear_Secret01()
	m_Info:Update_Info()
	
	HeartFireConfig.Frame.HF_Frame_NumberSeperator:Hide()
	HF_ICON:Hide()
	HeartFireConfig.Frame.HF_control_Top_Left:Show()
	HeartFireConfig.Frame.HF_control_Top_Right:Hide()
	
	epgp:Hide()
	m_Info:Show()
end

function SetFrame_NumberSeperator()
	HeartFireConfig.Frame.HF_Frame_NumberSeperator:Show()
	HF_ICON:Hide()
	HeartFireConfig.Frame.HF_control_Top_Left:Show()
	HeartFireConfig.Frame.HF_control_Top_Right:Show()
	epgp:Hide()
	m_Info:Hide()
end

function SetFrame_IconConfig()
	HeartFireConfig.Frame.HF_Frame_NumberSeperator:Hide()
	HF_ICON:Show()
	HeartFireConfig.Frame.HF_control_Top_Left:Show()
	HeartFireConfig.Frame.HF_control_Top_Right:Show()
	epgp:Hide()
	m_Info:Hide()
end

function SetFrame_EpGp()
	HeartFireConfig.Frame.HF_Frame_NumberSeperator:Hide()
	HF_ICON:Hide()
	HeartFireConfig.Frame.HF_control_Top_Left:Show()
	HeartFireConfig.Frame.HF_control_Top_Right:Hide()
	epgp:Show()
	m_Info:Hide()
end

function HF_Seperator()
	local id = HeartFireConfig.NumberSeperator.idSeperator
	if (HeartFireConfig.Seperator == nil) then
	
	else
		if (HeartFireConfig.Seperator.Probel == nil) then
		else
			if (id == 1) then
				HeartFireConfig.Seperator.Probel:SetChecked(true)
				HeartFireConfig.NumberSeperator.customSeperator = " "
			else
				HeartFireConfig.Seperator.Probel:SetChecked(false)
			end
		end
		if (HeartFireConfig.Seperator.TKCH == nil) then
		else
			if (id == 2) then
				HeartFireConfig.Seperator.TKCH:SetChecked(true)
				HeartFireConfig.NumberSeperator.customSeperator = "."
			else
				HeartFireConfig.Seperator.TKCH:SetChecked(false)
			end
		end
		if (HeartFireConfig.Seperator.Zapitai == nil) then
		else
			if (id == 3) then
				HeartFireConfig.Seperator.Zapitai:SetChecked(true)
				HeartFireConfig.NumberSeperator.customSeperator = ","
			else
				HeartFireConfig.Seperator.Zapitai:SetChecked(false)
			end
		end
		if (HeartFireConfig.Seperator.Custom == nil) then
		else
			if (id == 0) then
				HeartFireConfig.Seperator.Custom:SetChecked(true)
				HeartFireConfig.NumberSeperator.customSeperator = HeartFireConfig.Seperator.CustomED:GetText()
				HeartFireConfig.Seperator.CustomED:Enable()
			else
				HeartFireConfig.Seperator.Custom:SetChecked(false)
				HeartFireConfig.Seperator.CustomED:Disable()
			end
		end
	end
	
	if (HF_Save_Data.Addon_work == true) then		
		LARGE_NUMBER_SEPERATOR = HeartFireConfig.NumberSeperator.customSeperator
		HF_Save_Data.Seperator.idSeperator = id
		HF_Save_Data.Seperator.customSeperator = HeartFireConfig.NumberSeperator.customSeperator			
	end
end

function HeartFire_OnLoad()
	if (HF_Save_Data == nil) then HF_Save_Data = {} end		
	if (HF_Save_Data.Addon_work == nil) then HF_Save_Data.Addon_work = true end	
	if (HF_Save_Data.clearFramePosition == nil) then HF_Save_Data.clearFramePosition = true end
	HF_Save_Data.ActiveFrame = false
	if (HF_Save_Data.Seperator == nil) then HF_Save_Data.Seperator = {} end
	HeartFireConfig.NumberSeperator = { HF_Save_Data.Seperator.idSeperator, HF_Save_Data.Seperator.customSeperator }
	if (HF_Save_Data.Seperator.idSeperator == nil) then  else HeartFireConfig.NumberSeperator.idSeperator = HF_Save_Data.Seperator.idSeperator end
	if (HF_Save_Data.Seperator.customSeperator == nil) then HF_Save_Data.Seperator.customSeperator = 0 else HeartFireConfig.NumberSeperator.customSeperator = HF_Save_Data.Seperator.customSeperator end

	HF_Seperator()
end

function Enable_Addon()
	if (HF_Save_Data.Addon_work == true) then
		HF_Save_Data.Addon_work = false
		HeartFireConsole:Print("Сердце огня потухло") 
		if (HeartFireConfig.cbEnable:GetChecked() == true) then
			HeartFireConfig.cbEnable:SetChecked(false)
		end
		LARGE_NUMBER_SEPERATOR = ""
	else
		HF_Save_Data.Addon_work = true
		HeartFireConsole:Print("Сердце огня пылает") 
		if (HeartFireConfig.cbEnable:GetChecked() == false) then
			HeartFireConfig.cbEnable:SetChecked(true)
		end
		LARGE_NUMBER_SEPERATOR = HeartFireConfig.NumberSeperator.customSeperator
	end
	HF_ICON:Set_Icon()
end

function Position_Addon()
	if (HF_Save_Data.clearFramePosition == true) then
		HF_Save_Data.clearFramePosition = false
		HeartFireConsole:Print("Сердце огня свободно") 
		if (HeartFireConfig.cbPosition:GetChecked() == true) then
			HeartFireConfig.cbPosition:SetChecked(false)
		end
	else
		HF_Save_Data.clearFramePosition = true
		HeartFireConsole:Print("Сердце огня строго по центру") 
		if (HeartFireConfig.cbPosition:GetChecked() == false) then
			HeartFireConfig.cbPosition:SetChecked(true)
		end
		HeartFireConfig.Frame.HF_Frame_Main:ClearAllPoints() --  сброс позиционирования родителя фрэймов
		HeartFireConfig.Frame.HF_Frame_Main:SetPoint("CENTER") 
	end
end
