﻿-- инициализация модуля как библиотеки
local HF_EPGP = LibStub:NewLibrary("EpGp", 1)
local hfFrame = LibStub:GetLibrary("LibFrame")
local GS = LibStub:GetLibrary("LibGuildStorage")

local is_epgp_login
local isUpdate = true
local HF_ep_data = {}
local HF_gp_data = {}
local HF_main_data = {}
local HF_alt_data = {}
local my_alt = {}
local HF_ignored = {}
local _is_my_name, _ = UnitName("player")	
local font = GameFontNormal:GetFont()
local HF_Frame_EPGP, HF_Frame_EgGp_Config, HF_Frame_EgGp_Log, HF_Frame_EgGp_Log_Itogo, tInfo
local HF_control_EPGP, HF_control_EPGP_log
local actual_log_info = {}
local HF_ourRealmName = string.gsub(GetRealmName(), "%s+", "") 
local HF_selected = {}
HF_selected._count = 0
local sort_order, show_everyone = "PR", false
local standings = {}
local separater_epgp = " "
local hiddenOptions = {
	-- Names
	["ddl_Size_my_character"] = { prettyName = "Мой шрифт", description = "Размер шрифта строки с данными по моему персонажу (Имя, EP, GP, приоритет)", type = "number" },	
	["ddl_Size_any_character"] = { prettyName = "Остальных шрифт", description = "Размер шрифта строки с данными по другим персонажам (Имя, EP, GP, приоритет)", type = "number" }
}
local Widgets = {}
local HF_Log = {}

local tabl_EPGP
local HF_EPGP_config = {}
HF_EPGP_config.font_text_character = GameFontNormal:GetFont()
HF_EPGP_config.font_text = GameFontNormal:GetFont()

local HF_BUTTON_TEXT_PADDING = 20
local HF_BUTTON_HEIGHT = 22
local HF_ROW_TEXT_PADDING = 5

function HF_EPGP:Load_SaveVariable()
	if (HF_Save_Data.EpGp == nil) then HF_Save_Data.EpGp = {} end
	if (HF_Save_Data.EpGp.Size_text_character == nil) then HF_Save_Data.EpGp.Size_text_character = "10" end
	HF_EPGP_config.size_text_character = HF_Save_Data.EpGp.Size_text_character
	
	if (HF_Save_Data.EpGp.Size_text_any == nil) then HF_Save_Data.EpGp.Size_text_any = "10" end
	HF_EPGP_config.size_text = HF_Save_Data.EpGp.Size_text_any
	
	if (HF_Save_Data.EpGp.Only_Group_In_Group == nil) then RaidSelect = true end
	HF_EPGP_config.RaidSelect = RaidSelect
	
	if (HF_Save_Data.EpGp.Log == nil) then HF_Save_Data.EpGp.Log = {} end
	if (HF_Save_Data.EpGp.EP == nil) then HF_Save_Data.EpGp.EP = 0 end
	if (HF_Save_Data.EpGp.GP == nil) then HF_Save_Data.EpGp.GP = 0 end
	if (HF_Save_Data.EpGp.Log.History == nil) then HF_Save_Data.EpGp.Log.History = {} end
	is_epgp_login = true
end

function HF_EPGP_ParseGuildNote(callback, name, note)
	HF_EPGP:DeleteState(name)

	if note == "" then return end
	
	 
	local ep, gp = HF_EPGP:DecodeNote(note)
	if ep then
		HF_ep_data[name] = ep
		HF_gp_data[name] = gp
	else
		local mainName = note

		-- Allow specifying 'short' names in the officer notes, add the server by default
		mainName = HF_EPGP:GetFullCharacterName(mainName)

		local main_ep = HF_EPGP:DecodeNote(GS:GetNote(mainName))
		if not main_ep then
			-- This member does not point to a valid main, ignore it.
			HF_ignored[name] = mainName
		else
			-- Debug("Alt %s of %s", name, mainName)

			-- Otherwise setup the alts state
			HF_main_data[name] = mainName
			if not HF_alt_data[mainName] then
				HF_alt_data[mainName] = {}
			end
			table.insert(HF_alt_data[mainName], HF_EPGP:GetFullCharacterName(name))
			HF_ep_data[name] = nil
			HF_gp_data[name] = nil
		end
	end
	HF_EPGP:DestroyStandings()
	GS:SetOutsidersEnabled(true)
	if (_is_my_name.."-"..HF_ourRealmName == name) then
		Update_Log(name)
	else
		local myMain = HF_EPGP:GetFullCharacterName(note)
		if (myMain == nil) then return end
		for z=1, HF_EPGP:GetNumAlts(myMain) do
			if (_is_my_name.."-"..HF_ourRealmName == HF_EPGP:GetAlt(myMain, z)) then
				Update_Log(_is_my_name.."-"..HF_ourRealmName)
			end
		end
	end
end

function HF_EPGP:DeleteState(name)
	HF_ignored[name] = nil
	-- If this is was an alt we need to fix the alts state
	local main = HF_main_data[name]
	if main then
		if HF_alt_data[main] then
			for i,alt in ipairs(HF_alt_data[main]) do
				if alt == name then
					table.remove(HF_alt_data[main], i)
					break
				end
			end
		end
		HF_main_data[name] = nil
	end
	-- Delete any existing cached values
	HF_ep_data[name] = nil
	HF_gp_data[name] = nil
end

function HF_EPGP:GetFullCharacterName(name)
	if string.find(name, "%-") then
		return name;
	else
		return name .. "-" .. HF_ourRealmName;
	end
end

function HF_EPGP:DecodeNote(note)
	if note then
		if note == "" then
			return 0, 1
		else
			local ep, gp = string.match(note, "^(%d+),(%d+)$")
			if ep then
				if (gp == "0") then gp = "1" end
				return tonumber(ep), tonumber(gp)
			end
		end
	end
end

function HF_EPGP:GetEPGP(name)
	local main = HF_main_data[name]
	if main then
		name = main
	  end
	if HF_ep_data[name] then
		--if HF_ep_data[name] > 0 then
			return HF_ep_data[name], HF_gp_data[name], main
		--end
	end
end

function HF_EPGP:GetClass(name)
	return GS:GetClass(name)
end

function HF_EPGP:ComparatorWrapper(f)
	return function(a, b)
		if (HF_EPGP_config.RaidSelect) then
			local a_in_raid = not not UnitInRaid(Ambiguate(a, "none"))
			local b_in_raid = not not UnitInRaid(Ambiguate(b, "none"))
			if a_in_raid ~= b_in_raid then
				return not b_in_raid
			end
		end

		local a_selected = HF_selected[a]
		local b_selected = HF_selected[b]

		if a_selected ~= b_selected then
			return not b_selected
		end

		return f(a, b)
	end
end

local HF_comparators = {
	NAME = function(a, b)
		return a < b
	end,
	EP = function(a, b) 
		local a_ep, a_gp = HF_EPGP:GetEPGP(a)
		local b_ep, b_gp = HF_EPGP:GetEPGP(b)

		return a_ep > b_ep
	end,
	GP = function(a, b)
		local a_ep, a_gp = HF_EPGP:GetEPGP(a)
		local b_ep, b_gp = HF_EPGP:GetEPGP(b)

		return a_gp > b_gp
	end,
	PR = function(a, b)
		local a_ep, a_gp = HF_EPGP:GetEPGP(a)
		local b_ep, b_gp = HF_EPGP:GetEPGP(b)
		 
		local a_qualifies = a_ep >= 0
		local b_qualifies = b_ep >= 0

		if a_qualifies == b_qualifies then
			return a_ep/a_gp > b_ep/b_gp
		else
			return a_qualifies
		end
	end,
}
for k,f in pairs(HF_comparators) do
	HF_comparators[k] = HF_EPGP:ComparatorWrapper(f)
end

function HF_EPGP:UnitInRaid(name)
	return UnitInRaid(Ambiguate(name, "none"))
end

function HF_EPGP:Text_01()
	return "EpGp".."  —  |cFF0EE109Основная информация|r"
end

function HF_EPGP:Text_02()
	return "EpGp".."  —  |cFF0EE109Настройки|r"
end

function HF_EPGP:Text_03_01()
	return "EpGp".."  —  |cFF0EE109Журнал|r  —  |cFF0EE109Сводная|r"
end

function HF_EPGP:Text_03_02()
	return "EpGp".."  —  |cFF0EE109Журнал|r  —  |cFF0EE109Итоги|r"
end

function HF_EPGP:GetNumMembers()
	if #standings == 0 then
		HF_EPGP:RefreshStandings(sort_order, show_everyone)
	end

	return #standings
end

function HF_EPGP:RefreshStandings(order, showEveryone)
	if HF_EPGP_config.RaidSelect == true and UnitInRaid("player") then
		for n in pairs(HF_ep_data) do
			if UnitInRaid(Ambiguate(n, "none")) then
				table.insert(standings, n)
			end
		end
		for n in pairs(HF_main_data) do
			if UnitInRaid(Ambiguate(n, "none")) then
				table.insert(standings, n)
			end
		end
	else
		-- If we are not in raid, show all mains
		for n in pairs(HF_ep_data) do
			table.insert(standings, n)
		end
	end

	-- Sort
	table.sort(standings, HF_comparators[order])
end

function HF_EPGP:GetMinEP()
	return 0
end

function HF_EPGP:DestroyStandings()
	wipe(standings)
	HF_CallbackHandler:Fire("HF_EPGP_Changer_sort")
end

function HF_EPGP:GetMember(i)
	if #standings == 0 then
		HF_EPGP:RefreshStandings(sort_order, show_everyone)
	end

	return standings[i]
end

function HF_EPGP:SelectMember(name)
	if HF_EPGP_config.RaidSelect == true and UnitInRaid("player") then
		-- Only allow selecting members that are not in raid when in raid.
		if UnitInRaid(Ambiguate(name, "none")) then
			return false
		end
	end
	HF_selected[name] = true
	HF_selected._count = HF_selected._count + 1
	HF_EPGP:DestroyStandings()
	return true
end

function HF_EPGP:DeSelectMember(name)
	if HF_EPGP_config.RaidSelect == true and UnitInRaid("player") then
		-- Only allow deselecting members that are not in raid when in raid.
		if UnitInRaid(Ambiguate(name, "none")) then
			return false
		end
	end
	if not HF_selected[name] then
		return false
	end
	HF_selected[name] = nil
	HF_selected._count = HF_selected._count - 1
	HF_EPGP:DestroyStandings()
	return true
end

function HF_EPGP:StandingsSort(order)
	if not order then
		return sort_order
	end

	assert(HF_comparators[order], "Unknown sort order")

	sort_order = order
	HF_EPGP:DestroyStandings()
end

function HF_EPGP:GetNumAlts(name)
	local alts = HF_alt_data[name]
	if not alts then
		return 0
	else
		return #alts
	end
end

function HF_EPGP:GetDisplayCharacterName(name)
	local dashIndex = string.find(name, "%-")
	if not dashIndex then
		return name			-- Already short, we assume it's on our server
	end

	if HF_ourRealmName == string.sub(name, dashIndex + 1) then
		return string.sub(name, 1, dashIndex - 1)
	else
		return name
	end
end

function HF_EPGP:GetMain(name)
	return HF_main_data[name] or name
end

function HF_EPGP:GetClass(name)
	return GS:GetClass(name)
end

function HF_EPGP:StandingsShowEveryone(val)
	if val == nil then
		return show_everyone
	end

	show_everyone = not not val
	HF_EPGP:DestroyStandings()
end

function HF_EPGP:IsMemberInAwardList(name)
	if HF_EPGP_config.RaidSelect == true and UnitInRaid("player") then
		return UnitInRaid(Ambiguate(name, "none")) or HF_selected[name]
	else
		if HF_selected._count == 0 then
			return true
		end
		return HF_selected[name]
	end
end

function HF_EPGP:IsAnyMemberInExtrasList()
	return HF_selected._count ~= 0
end

function HF_EPGP:GetAlt(name, i)
	return HF_alt_data[name][i]
end

function Show_Frame()
	HF_Frame_EPGP:Show()
	HF_control_EPGP:Show()
	HF_info_EPGP:Show()
	HF_Frame_EgGp_Config:Hide()
	tInfo:SetText(HF_EPGP:Text_01())
	HF_Frame_EgGp_Log:Hide()
	HF_control_EPGP_log:Hide()
	HF_Frame_EgGp_Log_Itogo:Hide()
end

function Hide_Frame()
	HF_Frame_EPGP:Hide()
	HF_control_EPGP:Hide()
	HF_info_EPGP:Hide()
	HF_Frame_EgGp_Config:Hide()
	HF_Frame_EgGp_Log:Hide()
	HF_control_EPGP_log:Hide()
	HF_Frame_EgGp_Log_Itogo:Hide()
end

function Show_Frame_Config()
	HF_Frame_EgGp_Config:Show()
	HF_control_EPGP:Show()
	HF_info_EPGP:Show()
	HF_Frame_EPGP:Hide()
	tInfo:SetText(HF_EPGP:Text_02())
	HF_Frame_EgGp_Log:Hide()
	HF_control_EPGP_log:Hide()
	HF_Frame_EgGp_Log_Itogo:Hide()
end

function Hide_Frame_Config()
	HF_Frame_EgGp_Config:Hide()
	HF_control_EPGP:Hide()
	HF_info_EPGP:Hide()
	HF_Frame_EPGP:Hide()
	HF_Frame_EgGp_Log:Hide()
	HF_control_EPGP_log:Hide()
	HF_Frame_EgGp_Log_Itogo:Hide()
end

function Show_Frame_Log()
	HF_Frame_EgGp_Config:Hide()
	HF_Frame_EgGp_Log:Show()
	HF_control_EPGP:Show()
	HF_info_EPGP:Show()
	HF_Frame_EPGP:Hide()
	tInfo:SetText(HF_EPGP:Text_03_01())
	HF_control_EPGP_log:Show()
	HF_Frame_EgGp_Log_Itogo:Hide()
end

function Hide_Frame_Log()
	HF_Frame_EgGp_Config:Hide()
	HF_control_EPGP:Hide()
	HF_info_EPGP:Hide()
	HF_Frame_EPGP:Hide()
	HF_Frame_EgGp_Log:Hide()
	HF_control_EPGP_log:Hide()
	HF_Frame_EgGp_Log_Itogo:Hide()
end

function Show_Frame_Log_Itogo()
	HF_Frame_EgGp_Config:Hide()
	HF_Frame_EgGp_Log:Hide()
	HF_control_EPGP:Show()
	HF_info_EPGP:Show()
	HF_Frame_EPGP:Hide()
	tInfo:SetText(HF_EPGP:Text_03_02())
	HF_control_EPGP_log:Show()
	HF_Frame_EgGp_Log_Itogo:Show()
	HF_EPGP:EpGp_Log_Itogo()
end

function Hide_Frame_Log_Itogo()
	HF_Frame_EgGp_Config:Hide()
	HF_control_EPGP:Hide()
	HF_info_EPGP:Hide()
	HF_Frame_EPGP:Hide()
	HF_Frame_EgGp_Log:Hide()
	HF_control_EPGP_log:Hide()
	HF_Frame_EgGp_Log_Itogo:Hide()
end

function HF_EPGP:Show()
	Show_Frame()
end

function HF_EPGP:Hide()
	Hide_Frame()
end

function HF_EPGP:StandingsSort(order)
	if not order then
		return sort_order
	end

	assert(HF_comparators[order], "Unknown sort order")

	sort_order = order
	HF_EPGP:DestroyStandings()
end

function HF_EPGP:CreateTable(parent, texts, widths, justfiesH, rightPadding)
	assert(#texts == #widths and #texts == #justfiesH,
	"All specification tables must be the same size")
	-- Compute widths
	local totalFixedWidths = rightPadding or 0
	local numDynamicWidths = 0
	for i,w in ipairs(widths) do
		if w > 0 then
			totalFixedWidths = totalFixedWidths + w
		else
			numDynamicWidths = numDynamicWidths + 1
		end
	end
	local remainingWidthSpace = parent:GetWidth() - totalFixedWidths
	assert(remainingWidthSpace >= 0, "Указанная ширина "..remainingWidthSpace.." превышает пороговую ширину "..parent:GetWidth().." "..totalFixedWidths)

	local dynamicWidth = math.floor(remainingWidthSpace / numDynamicWidths)
	local leftoverWidth = remainingWidthSpace % numDynamicWidths
	for i,w in ipairs(widths) do
		if w <= 0 then
			numDynamicWidths = numDynamicWidths - 1
			if numDynamicWidths then
				widths[i] = dynamicWidth
			else
				widths[i] = dynamicWidth + leftoverWidth
			end
		end
	end

	-- Make headers
	parent.headers = {}
	for i=1,#texts do
		local text, width, justifyH = texts[i], widths[i], justfiesH[i]
		local h = hfFrame:CreateTableHeader(parent, text, width)
		h:SetNormalFontObject("GameFontHighlightSmall")
		h:SetText(text)
		h:GetFontString():SetJustifyH(justifyH)
		h:SetWidth(width)
		if #parent.headers == 0 then
			h:SetPoint("TOPLEFT")
		else
			h:SetPoint("TOPLEFT", parent.headers[#parent.headers], "TOPRIGHT")
		end
		table.insert(parent.headers, h)
	end

	-- Make a frame for the rows
	local rowFrame = CreateFrame("Frame", nil, parent)
	rowFrame:SetPoint("TOP", parent.headers[#parent.headers], "BOTTOM")
	rowFrame:SetPoint("BOTTOMLEFT")
	rowFrame:SetPoint("BOTTOMRIGHT", parent, "BOTTOMRIGHT", -rightPadding, 0)
	parent.rowFrame = rowFrame

	-- Compute number of rows
	local fontHeightMax, fontHeightMin
	local rowHeight
	local numRows
  
	if (HF_Save_Data.EpGp.Size_text_character > HF_Save_Data.EpGp.Size_text_any) then 		
		rowHeight = HF_Save_Data.EpGp.Size_text_any + 4
		rowFrame.rowHeight = HF_Save_Data.EpGp.Size_text_character + 4
		numRows = math.floor((rowFrame:GetHeight() - HF_Save_Data.EpGp.Size_text_character - 4) / rowHeight) + 1
	else 
		rowHeight = HF_Save_Data.EpGp.Size_text_any + 4
		rowFrame.rowHeight = rowHeight
		numRows = math.floor((rowFrame:GetHeight() - HF_Save_Data.EpGp.Size_text_character - 4) / rowHeight) + 1
	end

	numRows = numRows + 50

	-- Make rows
	rowFrame.rows = {}
	for i=1,numRows do
		local r = hfFrame:CreateTableRow(rowFrame, rowHeight, widths, justfiesH)
		if #rowFrame.rows == 0 then
			r:SetPoint("TOP")
		else
			r:SetPoint("TOP", rowFrame.rows[#rowFrame.rows], "BOTTOM")
		end
		table.insert(rowFrame.rows, r)
	end
end

function HF_EPGP:Control_Number(n)
	local left,num,right = string.match(n,'^([^%d]*%d)(%d*)(.-)$')
	return left..(num:reverse():gsub('(%d%d%d)','%1'..separater_epgp):reverse())..right
end

function HF_EPGP:Load_EgGp(HF_Frame_Main, HeartFire)

	HF_EPGP:Load_EpGp_Main_Frame(HF_Frame_Main, HeartFire)
	HF_EPGP:Load_EgGp_Config(HF_Frame_Main)	
	HF_EPGP:Load_EgGp_Log(HF_Frame_Main, HeartFire)
	HF_EPGP:Load_EpGp_Log_Itogo(HF_Frame_Main)
			
	return HF_Frame_EPGP, HF_control_EPGP
end 

function Update_Log(name)
	local nameMain = HF_EPGP:GetMain(name)
	if (nameMain ~= nil) then
		if ((#my_alt == 0 and nameMain ~= name and HF_EPGP:GetNumAlts(nameMain) > 0) or (#my_alt < HF_EPGP:GetNumAlts(nameMain) and nameMain ~= name)) then
			wipe(my_alt)
			for i=1,HF_EPGP:GetNumAlts(nameMain) do
				local altName = HF_EPGP:GetAlt(nameMain, i)
				altName = HF_EPGP:GetDisplayCharacterName(altName)
				table.insert(my_alt, altName)
			end
		end

		local isTrue = false
		if (#my_alt > 0) then
			for t=1,#my_alt do
				if(name == my_alt[t]) then
					isTrue = true
				end
			end
		end
		
		local ep, gp
		
		if (isTrue == true) then
			if (nameMain == nil) then return end
			ep, gp = HF_EPGP:GetEPGP(nameMain)
		else
			ep, gp = HF_EPGP:GetEPGP(name)
		end
					
		local info = HF_EPGP:Add_Log(ep, gp, nameMain, name)
		if (info.Active == true) then
			HF_EPGP:Save_Log(info)
		end
	end
end

function HF_EPGP:Load_EpGp_Main_Frame(HF_Frame_Main, HeartFire)
	
	GS.RegisterCallback(self, "GuildNoteChanged", HF_EPGP_ParseGuildNote)
	HF_Frame_EPGP = hfFrame:Get_Frame("HF_Frame_EGPG", HF_Frame_Main, 750, 400, "Right")	
	HF_info_EPGP = hfFrame:Get_Frame("HF_info_EPGP", HF_Frame_Main, 750, 30, "TOPRIGHT")
	HF_control_EPGP = hfFrame:Get_Frame("HF_control_EPGP", HF_Frame_Main, 750, 30, "BOTTOMRIGHT")
	HF_control_EPGP_log = hfFrame:Get_Frame("HF_control_EPGP", HF_Frame_Main, 350, 30, "BOTTOMRIGHT")
	HF_control_EPGP_log:SetPoint("BOTTOMRIGHT", HF_Frame_Main, "BOTTOMRIGHT", -325, -30)
		
	tInfo = hfFrame:Get_Text(HF_info_EPGP, 13, HF_EPGP:Text_01(), font, "TOPLEFT", 20, -10)		
	
	local button = CreateFrame("Button", "btMainInfo_EPGP", HF_control_EPGP)
	button:SetPoint("TopLeft", HF_control_EPGP, "TopLeft", 10, -3)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Основная информация")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", Show_Frame)	
	
	button = hfFrame:Get_Texture_Button(button)
	
	button = CreateFrame("Button", "btMainInfo_EPGP_log", HF_control_EPGP)
	button:SetPoint("TopLeft", HF_control_EPGP, "TopLeft", 170, -3)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Журнал")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", Show_Frame_Log)	
	
	button = hfFrame:Get_Texture_Button(button)
	
	button = CreateFrame("Button", "btMainInfo_EPGP_config", HF_control_EPGP)
	button:SetPoint("TopLeft", HF_control_EPGP, "TopLeft", 330, -3)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Настройки")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", Show_Frame_Config)	
	
	button = hfFrame:Get_Texture_Button(button)
	
	
	button = CreateFrame("Button", "btMainInfo_EPGP_log_main_info", HF_control_EPGP_log)
	button:SetPoint("TopLeft", HF_control_EPGP_log, "TopLeft", 10, -3)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Сводная")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", Show_Frame_Log)	
	
	button = hfFrame:Get_Texture_Button(button)
	
	button = CreateFrame("Button", "btMainInfo_EPGP_log_main_info", HF_control_EPGP_log)
	button:SetPoint("TopLeft", HF_control_EPGP_log, "TopLeft", 170, -3)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Итоги")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", Show_Frame_Log_Itogo)	
	
	button = hfFrame:Get_Texture_Button(button)
	
	HF_EPGP:Load_Table_EPGP(HeartFire)
end

function HF_EPGP:Load_Table_EPGP(HeartFire)
	tabl_EPGP = CreateFrame("Frame", "table_epgp_info", HF_Frame_EPGP)
	tabl_EPGP:SetPoint("TOPLEFT")
	tabl_EPGP:SetPoint("TOPRIGHT")
	tabl_EPGP:SetPoint("BOTTOM", HF_control_EPGP, "TOP")
	HF_EPGP:CreateTable(tabl_EPGP,
	{"Имя", "EP", "GP", "Приоритет"},
	{0, 128, 128, 128},
	{"LEFT", "RIGHT", "RIGHT", "RIGHT"},
	27)
	
	local rowFrame = tabl_EPGP.rowFrame
	rowFrame.needUpdate = true
	local scrollBar = CreateFrame("ScrollFrame", "HF_EPGP_ScrollFrame",
	rowFrame, "FauxScrollFrameTemplateLight")
	scrollBar:SetWidth(rowFrame:GetWidth())
	scrollBar:SetPoint("TOPRIGHT", rowFrame, "TOPRIGHT", 0, -8)
	scrollBar:SetPoint("BOTTOMRIGHT", 0, 8)

	-- Make all our rows have a check on them and setup the OnClick
	-- handler for each row.
	for i,r in ipairs(rowFrame.rows) do
		r.check = r:CreateTexture(nil, "BACKGROUND")
		r.check:SetTexture("Interface\\Buttons\\UI-CheckBox-Check")
		r.check:SetWidth(r:GetHeight())
		r.check:SetHeight(r:GetHeight())
		r.check:SetPoint("RIGHT", r.cells[1])

		r:RegisterForClicks("LeftButtonDown")
		r:SetScript(
		"OnClick",
		function(self, value)
			if IsModifiedClick("QUESTWATCHTOGGLE") then
				if self.check:IsShown() then
					HF_EPGP:DeSelectMember(self.name)
				else
					HF_EPGP:SelectMember(self.name)
				end
			else
			end
		end)

		r:SetScript(
		"OnEnter",
		function(self) -- всплывающее окно, при наведении на строку с данными, показывает информацию о мейнах и альтах
			GameTooltip_SetDefaultAnchor(GameTooltip, self)
			GameTooltip:AddLine(GS:GetRank(self.name))
			if HF_EPGP:GetNumAlts(self.name) > 0 then
				GameTooltip:AddLine("\nАльты")					  
				for i=1,HF_EPGP:GetNumAlts(self.name) do
					local altName = HF_EPGP:GetAlt(self.name, i)
					altName = HF_EPGP:GetDisplayCharacterName(altName)
					GameTooltip:AddLine(altName, 1, 1, 1)
				end
			elseif HF_EPGP:GetMain(self.name) ~= self.name then
				GameTooltip:AddLine("\nОсновной персонаж")
				GameTooltip:AddLine(HF_EPGP:GetMain(self.name), 1, 1, 1)
			end
			GameTooltip:ClearAllPoints()
			GameTooltip:SetPoint("TOPLEFT", self, "TOPRIGHT")
			GameTooltip:Show()
		end)
		r:SetScript("OnLeave", function() GameTooltip:Hide() end)
	end
			  
	tabl_EPGP.headers[1]:SetScript("OnClick", function(self) HF_EPGP:StandingsSort("NAME") end)
	tabl_EPGP.headers[2]:SetScript("OnClick", function(self) HF_EPGP:StandingsSort("EP") end)
	tabl_EPGP.headers[3]:SetScript("OnClick", function(self) HF_EPGP:StandingsSort("GP") end)
	tabl_EPGP.headers[4]:SetScript("OnClick", function(self) HF_EPGP:StandingsSort("PR") end)
	
	local function UpdateStandings_EPGP_HF()
		if not rowFrame.needUpdate then return end
		local rowHeight, numRows
		if (HF_Save_Data.EpGp.Size_text_character > HF_Save_Data.EpGp.Size_text_any) then 		
			rowHeight = HF_Save_Data.EpGp.Size_text_any + 4
			rowFrame.rowHeight = HF_Save_Data.EpGp.Size_text_character + 4
			numRows = math.floor((rowFrame:GetHeight() - HF_Save_Data.EpGp.Size_text_character - 4) / rowHeight) + 1
		else 
			rowHeight = HF_Save_Data.EpGp.Size_text_any + 4
			rowFrame.rowHeight = rowHeight
			numRows = math.floor((rowFrame:GetHeight() - HF_Save_Data.EpGp.Size_text_character - 4) / rowHeight) + 1
		end
	
		local offset = FauxScrollFrame_GetOffset(HF_EPGP_ScrollFrame)
		local numMembers = HF_EPGP:GetNumMembers()
		local numDisplayedMembers = math.min(numRows, numMembers - offset)
		local minEP = HF_EPGP:GetMinEP()
		for i=1,#rowFrame.rows do
			local row = rowFrame.rows[i]
			local j = i + offset			
			if j <= numMembers then
				row.name = HF_EPGP:GetMember(j)
				row.cells[1]:SetText(Ambiguate(row.name, "short"))
				local c = RAID_CLASS_COLORS[HF_EPGP:GetClass(row.name)]
				row.cells[1]:SetTextColor(c.r, c.g, c.b)					
				local ep, gp = HF_EPGP:GetEPGP(row.name)
				row.cells[2]:SetText(HF_EPGP:Control_Number(ep))
				row.cells[3]:SetText(HF_EPGP:Control_Number(gp))
				local pr = 0
				if gp then
					pr = ep / gp
				end
				if pr > 9999 then
					row.cells[4]:SetText(math.floor(pr))
				else
					row.cells[4]:SetFormattedText("%.4g", pr)
				end
				row.check:Hide()
				if HF_EPGP_config.RaidSelect == true and UnitInRaid("player") and HF_EPGP:StandingsShowEveryone() then
					if HF_EPGP:IsMemberInAwardList(row.name) then
						row.check:Show()
					end
				elseif HF_EPGP:IsAnyMemberInExtrasList() then
					if HF_EPGP:IsMemberInAwardList(row.name) then
						row.check:Show()
					end
				end
				row:SetAlpha(ep < minEP and 0.6 or 1)
				row:Show()
				
				if (_is_my_name == Ambiguate(row.name, "short")) then
					row.cells[1]:SetFont(HF_EPGP_config.font_text_character, HF_EPGP_config.size_text_character)			
					row.cells[2]:SetFont(HF_EPGP_config.font_text_character, HF_EPGP_config.size_text_character)			
					row.cells[3]:SetFont(HF_EPGP_config.font_text_character, HF_EPGP_config.size_text_character)			
					row.cells[4]:SetFont(HF_EPGP_config.font_text_character, HF_EPGP_config.size_text_character)	
					row:SetHeight(HF_EPGP_config.size_text_character + 4)		
				else
					row.cells[1]:SetFont(HF_EPGP_config.font_text, HF_EPGP_config.size_text)			
					row.cells[2]:SetFont(HF_EPGP_config.font_text, HF_EPGP_config.size_text)			
					row.cells[3]:SetFont(HF_EPGP_config.font_text, HF_EPGP_config.size_text)			
					row.cells[4]:SetFont(HF_EPGP_config.font_text, HF_EPGP_config.size_text)	
					row:SetHeight(HF_EPGP_config.size_text + 4)
				end
			else
				row:Hide()
			end
			-- Fix the highlighting of the rows
			if row.name == HF_Frame_EPGP.name then
				row:LockHighlight()
			else
				row:UnlockHighlight()
			end
		end

		for i=1,#rowFrame.rows do
			if (i <= numDisplayedMembers) then rowFrame.rows[i]:Show() else rowFrame.rows[i]:Hide() end
		end
		FauxScrollFrame_Update(HF_EPGP_ScrollFrame, numMembers, numDisplayedMembers,
		rowFrame.rowHeight, nil, nil, nil, nil,
		nil, nil, true)
		HF_Frame_EPGP:SetScript(
		"OnHide",
		function(self)
			self.name = nil
			rowFrame.needUpdate = true
			UpdateStandings_EPGP_HF()
		end)
		rowFrame.needUpdate = nil
	end

	rowFrame:SetScript("OnUpdate", UpdateStandings_EPGP_HF)
	HeartFire.RegisterCallback(rowFrame, "HF_EPGP_Changer_sort", function() rowFrame.needUpdate = true end)
	rowFrame:SetScript("OnShow", UpdateStandings_EPGP_HF)
	scrollBar:SetScript(
	"OnVerticalScroll",
	function(self, value)
		rowFrame.needUpdate = true
		FauxScrollFrame_OnVerticalScroll(
		self, value, rowFrame.rowHeight, UpdateStandings_EPGP_HF)
	end)	
		
end

function HF_EPGP:Add_Log(ep, gp, nameMain, nameActiveCharacter)
	local info = { Active, DateTime, Ep, Gp, NameMain, NameActiveCharacter, Login, AddEP, AddGP, DateToString, TimeToString }
	info.Login = is_epgp_login
	info.Active = false
	info.DateTime = date("*t") -- returns { hour=1, min=31, sec=41, wday=1, day=14, month=6, year=2009, yday=165, isdst=true }
	local oldEP, oldGP = HF_Save_Data.EpGp.EP, HF_Save_Data.EpGp.GP
	info.Ep = oldEP
	info.Gp = oldGP
	info.NameMain = nameMain
	info.NameActiveCharacter = nameActiveCharacter
	info.DateToString = NumberDateToString(info.DateTime.day).."."..NumberDateToString(info.DateTime.month).."."..tostring(info.DateTime.year)
	info.TimeToString = NumberDateToString(info.DateTime.hour)..":"..NumberDateToString(info.DateTime.min)..":"..NumberDateToString(info.DateTime.sec)
	info.AddGP = 0
	if (oldEP ~= ep) then 
		info.Ep = ep
		local det
		info.Active = true
		if (oldEP < ep) then 
			det = "+" 
		else 
			det = "-" 
		end
		info.AddEP = ep - oldEP
		HF_Save_Data.EpGp.EP = ep
	else
		info.AddEP = 0
	end

	if (oldGP ~= gp) then 
		info.Gp = gp
		local det
		info.Active = true
		if (oldGP < gp) then 
			det = "+" 
		else 
			det = "-" 
		end
		info.AddGP = gp - oldGP		
		HF_Save_Data.EpGp.GP = gp
	else
		info.AddGP = 0
	end
	
	if (is_epgp_login == true) then
		is_epgp_login = false
	end
	return info
end

function HF_EPGP:Save_Log(logs)
	local info = { DateTime, Login, Ep, Gp, NameMain, MainClass, MainColor, NameActiveCharacter, ActiveCharacterClass, ActiveCharacterColor, NameRealm, AddEP, AddGP, DateToString, TimeToString }
	info.DateTime = logs.DateTime
	info.Login = logs.Login
	info.Ep = logs.Ep
	info.Gp = logs.Gp
	info.DateToString = logs.DateToString
	info.TimeToString = logs.TimeToString
	info.NameMain = HF_EPGP:GetDisplayCharacterName(logs.NameMain)
	info.NameActiveCharacter = HF_EPGP:GetDisplayCharacterName(logs.NameActiveCharacter)
	info.AddEP = logs.AddEP
	info.AddGP = logs.AddGP
	info.NameRealm = HF_ourRealmName
	info.MainClass = HF_EPGP:GetClass(logs.NameMain)
	info.MainColor = RAID_CLASS_COLORS[HF_EPGP:GetClass(logs.NameMain)]
	info.ActiveCharacterClass = HF_EPGP:GetClass(logs.NameActiveCharacter)
	info.ActiveCharacterColor = RAID_CLASS_COLORS[HF_EPGP:GetClass(logs.NameActiveCharacter)]
	
	table.insert(HF_Save_Data.EpGp.Log.History, info)
end

function NumberDateToString(number)
	if (number > 10) then
		return tostring(number)
	else
		return "0"..tostring(number)
	end
end

function HF_EPGP:Load_EgGp_Config(HF_Frame_Main)	
	HF_Frame_EgGp_Config = hfFrame:Get_Frame("HF_Frame_EGPG_config", HF_Frame_Main, 750, 400, "Right")	
	
	local text_Size_info_01 = HF_Frame_EgGp_Config:CreateFontString(nil, 'ARTWORK', 'GameFontHighlightSmall')
	text_Size_info_01:SetPoint('TOPLEFT', HF_Frame_EgGp_Config, 'TOPLEFT', 22, 0)
	
	local ddl_Size_my_character = hfFrame:newSlider(hiddenOptions, HF_Frame_EgGp_Config, 'ddl_Size_my_character', 10, 30, 1, 25, Widgets,
	function(self, value)
		HF_EPGP_config.size_text_character = tostring(value)
		HF_Save_Data.EpGp.Size_text_character = tostring(value)
		local rowHeight, numRows 
		local rowFrame = tabl_EPGP.rowFrame
		if (HF_Save_Data.EpGp.Size_text_character > HF_Save_Data.EpGp.Size_text_any) then 		
			rowHeight = HF_Save_Data.EpGp.Size_text_any + 4
			rowFrame.rowHeight = HF_Save_Data.EpGp.Size_text_character + 4
			numRows = math.floor((rowFrame:GetHeight() - HF_Save_Data.EpGp.Size_text_character - 4) / rowHeight) + 1
		else 
			rowHeight = HF_Save_Data.EpGp.Size_text_any + 4
			rowFrame.rowHeight = rowHeight
			numRows = math.floor((rowFrame:GetHeight() - HF_Save_Data.EpGp.Size_text_character - 4) / rowHeight) + 1
		end
		
		for i=1,#rowFrame.rows do
			if (i <= numRows) then rowFrame.rows[i]:Show() else rowFrame.rows[i]:Hide() end
		end
		
		local numMembers = HF_EPGP:GetNumMembers()
		local numDisplayedMembers = numRows
		FauxScrollFrame_Update(HF_EPGP_ScrollFrame, numMembers, numDisplayedMembers,
			rowFrame.rowHeight, nil, nil, nil, nil,
			nil, nil, true)
		HF_EPGP:StandingsSort(sort_order)
	end)
	ddl_Size_my_character:SetPoint('TOPLEFT', text_Size_info_01, 'BOTTOMLEFT', 20, -20)
	ddl_Size_my_character:SetValue(tonumber(HF_EPGP_config.size_text_character))
	
	local ddl_Size_any_character = hfFrame:newSlider(hiddenOptions, HF_Frame_EgGp_Config, 'ddl_Size_any_character', 10, 30, 1, 15, Widgets,
	function(self, value)
		HF_EPGP_config.size_text = tostring(value)
		HF_Save_Data.EpGp.Size_text_any = tostring(value)
		local rowHeight, numRows 
		local rowFrame = tabl_EPGP.rowFrame
		if (HF_Save_Data.EpGp.Size_text_character > HF_Save_Data.EpGp.Size_text_any) then 		
			rowHeight = HF_Save_Data.EpGp.Size_text_any + 4
			rowFrame.rowHeight = HF_Save_Data.EpGp.Size_text_character + 4
			numRows = math.floor((rowFrame:GetHeight() - HF_Save_Data.EpGp.Size_text_character - 4) / rowHeight) + 1
		else 
			rowHeight = HF_Save_Data.EpGp.Size_text_any + 4
			rowFrame.rowHeight = rowHeight
			numRows = math.floor((rowFrame:GetHeight() - HF_Save_Data.EpGp.Size_text_character - 4) / rowHeight) + 1
		end
		
		for i=1,#rowFrame.rows do
			if (i <= numRows) then rowFrame.rows[i]:Show() else rowFrame.rows[i]:Hide() end
		end
		
		local numMembers = HF_EPGP:GetNumMembers()
		local numDisplayedMembers = numRows
		FauxScrollFrame_Update(HF_EPGP_ScrollFrame, numMembers, numDisplayedMembers,
			rowFrame.rowHeight, nil, nil, nil, nil,
			nil, nil, true)
		HF_EPGP:StandingsSort(sort_order)
	end)
	ddl_Size_any_character:SetPoint('TOPLEFT', ddl_Size_my_character, 'BOTTOMLEFT', 0, -40)
	ddl_Size_any_character:SetValue(tonumber(HF_EPGP_config.size_text))
				
	local cb_raid_select = CreateFrame("CheckButton", "cb_raid_select", HF_Frame_EgGp_Config, "ChatConfigCheckButtonTemplate")
	cb_raid_select:SetPoint("TOPLEFT", ddl_Size_any_character, 'TOPLEFT',-20, -50)
	cb_raid_select:SetChecked(HF_EPGP_config.RaidSelect)
	cb_raid_select:SetScript("OnClick", function() 
		HF_EPGP_config.RaidSelect = cb_raid_select:GetChecked() 
		RaidSelect = HF_EPGP_config.RaidSelect		
		local numMembers = HF_EPGP:GetNumMembers()
		local offset = FauxScrollFrame_GetOffset(HF_EPGP_ScrollFrame)
		
		local rowHeight, numRows 
		local rowFrame = tabl_EPGP.rowFrame
		if (HF_Save_Data.EpGp.Size_text_character > HF_Save_Data.EpGp.Size_text_any) then 		
			rowHeight = HF_Save_Data.EpGp.Size_text_any + 4
			rowFrame.rowHeight = HF_Save_Data.EpGp.Size_text_character + 4
			numRows = math.floor((rowFrame:GetHeight() - HF_Save_Data.EpGp.Size_text_character - 4) / rowHeight) + 1
		else 
			rowHeight = HF_Save_Data.EpGp.Size_text_any + 4
			rowFrame.rowHeight = rowHeight
			numRows = math.floor((rowFrame:GetHeight() - HF_Save_Data.EpGp.Size_text_character - 4) / rowHeight) + 1
		end				
		
		local numDisplayedMembers = math.min(numRows, numMembers - offset)
		for i=1,#rowFrame.rows do
			if (i <= numDisplayedMembers) then rowFrame.rows[i]:Show() else rowFrame.rows[i]:Hide() end
		end
		
		FauxScrollFrame_Update(HF_EPGP_ScrollFrame, numMembers, numDisplayedMembers,
		rowFrame.rowHeight, nil, nil, nil, nil,
		nil, nil, true)
		HF_EPGP:StandingsSort(sort_order)
	end)		
	
	local text_raid_select = HF_Frame_EgGp_Config:CreateFontString(nil, 'ARTWORK', 'GameFontHighlightSmall')
	text_raid_select:SetPoint('TOPLEFT', ddl_Size_any_character, 'TOPLEFT', 5, -55)
	text_raid_select:SetText('Только члены группы/рейда в списке')
end

function Get_Logs_HF_EPGP(i)
	local History = HF_Log[i]
	local info = { DateTime, Login, Ep, Gp, NameMain, MainClass, MainColor, NameActiveCharacter, ActiveCharacterClass, ActiveCharacterColor, NameRealm, AddEP, AddGP, DateToString, TimeToString }
	info.DateTime = History.DateTime
	info.Login = History.Login
	info.Ep = History.Ep
	info.Gp = History.Gp
	info.DateToString = History.DateToString
	info.TimeToString = History.TimeToString
	info.NameMain = History.NameMain
	info.NameActiveCharacter = History.NameActiveCharacter
	info.AddEP = History.AddEP
	info.AddGP = History.AddGP
	info.NameRealm = History.NameRealm
	info.MainClass = History.MainClass
	info.MainColor = History.MainColor
	info.ActiveCharacterClass = History.ActiveCharacterClass
	info.ActiveCharacterColor = History.ActiveCharacterColor
	
	return info.DateTime, info.Login, info.Ep, info.Gp, info.NameMain, info.MainClass, info.MainColor, info.NameActiveCharacter, info.ActiveCharacterClass, info.ActiveCharacterColor, 
			info.NameRealm, info.AddEP, info.AddGP, info.DateToString, info.TimeToString
end

function HF_EPGP:Load_EgGp_Log(HF_Frame_Main, HeartFire)	
	HF_Frame_EgGp_Log = hfFrame:Get_Frame("HF_Frame_EgGp_Log", HF_Frame_Main, 750, 400, "Right")
	
	local tabl_logs = CreateFrame("Frame", "table_epgp_info", HF_Frame_EgGp_Log)
	tabl_logs:SetPoint("TOPLEFT")
	tabl_logs:SetPoint("TOPRIGHT")
	tabl_logs:SetPoint("BOTTOM", HF_control_EPGP, "TOP")
	hfFrame:CreateTable(tabl_logs,
	{"Дата", "Офф", "EP", "GP", "Меин", "Заработал", "Итого EP", "Итого GP"},
	{0, 35, 80, 80, 100, 100, 70, 70},
	{"LEFT", "RIGHT", "RIGHT", "RIGHT", "RIGHT", "RIGHT", "RIGHT", "RIGHT"},
	27)
		
	wipe(HF_Log)	
	local t = 1
	for list = #HF_Save_Data.EpGp.Log.History, 1, -1 do
		if variable == 0 then
			break
		end
		table.insert(HF_Log, HF_Save_Data.EpGp.Log.History[list])
	end	
	
	
	local rowFrame = tabl_logs.rowFrame
	rowFrame.needUpdate = true
	local scrollBar = CreateFrame("ScrollFrame", "HF_EPGP_Log_ScrollFrame",
	rowFrame, "FauxScrollFrameTemplateLight")
	scrollBar:SetWidth(rowFrame:GetWidth())
	scrollBar:SetPoint("TOPRIGHT", rowFrame, "TOPRIGHT", 0, -8)
	scrollBar:SetPoint("BOTTOMRIGHT", 0, 8)
	
	tabl_logs.headers[2]:SetScript("OnEnter",
		function(self) -- всплывающее окно, при наведении на строку с данными, показывает информацию о мейнах и альтах
			GameTooltip_SetDefaultAnchor(GameTooltip, self)
			GameTooltip:AddLine("Офф")	
			GameTooltip:AddLine("\nEp и Gp могут быть изменены РЛ в".."\n"..
								"любой момент времени, даже тогда,".."\n"..
								"когда персонаж оффлайн. Данные".."\n"..
								"тогда загружаются при заходе в".."\n"..
								"игру. В этом случае в этом столбце".."\n"..
								"ставится метка, что данные были".."\n"..
								"загружены при входе в игру и".."\n"..
								"изменены, пока персонаж был".."\n"..
								"оффлайн", 1, 1, 1)
			GameTooltip:ClearAllPoints()
			GameTooltip:SetPoint("TOPLEFT", self, "TOPRIGHT")
			GameTooltip:Show()
		end)
	tabl_logs.headers[2]:SetScript("OnLeave", function() GameTooltip:Hide() end)

	
	
	local function Update_Log_EPGP_HF()
		if not rowFrame.needUpdate then return end		
		local fontHeight = 13 + 2
		local rowHeight = fontHeight + 4
		rowFrame.rowHeight = rowHeight
		local numRows = math.floor(rowFrame:GetHeight() / rowHeight)
	
		local offset = FauxScrollFrame_GetOffset(HF_EPGP_Log_ScrollFrame)
		local numMembers = #HF_Log
		local numDisplayedMembers = math.min(numRows, numMembers - offset)
		for i=1,#rowFrame.rows do
			local row = rowFrame.rows[i]
			local j = i + offset			
			if j <= numMembers then
				row.name = tostring(j)
				local DateTime, Login, Ep, Gp, NameMain, MainClass, MainColor, NameActiveCharacter, ActiveCharacterClass, ActiveCharacterColor, 
					  NameRealm, AddEP, AddGP, DateToString, TimeToString
								= Get_Logs_HF_EPGP(j)
								
				row:SetScript("OnEnter",
					function(self) -- всплывающее окно, при наведении на строку с данными, показывает информацию о мейнах и альтах
						local pr = 0
						local ep, gp = tonumber(row.cells[7]:GetText()), tonumber(row.cells[8]:GetText())
						if gp then
							pr = ep / gp
						end
						GameTooltip_SetDefaultAnchor(GameTooltip, self)
						GameTooltip:AddLine("Информация".."\n")	
						if pr > 9999 then								
							GameTooltip:AddLine("Приоритет: |cFF7DBEFF"..math.floor(pr).."|r", 1, 1, 1)
						else
							GameTooltip:AddLine("Приоритет: |cFF7DBEFF"..string.format("%.4g", pr).."|r", 1, 1, 1)
						end
						
						if (row.cells[2]:GetText() ~= nil) then
							GameTooltip:AddLine("\n".."Данные были получены".."\n".."при загрузке", 1, 1, 1)
						end
						
						GameTooltip:ClearAllPoints()
						GameTooltip:SetPoint("TOPLEFT", self, "TOPRIGHT")
						GameTooltip:Show()
					end)
				row:SetScript("OnLeave", function() GameTooltip:Hide() end)
								
				local isLoad, reaAction = "", ""
				if (Login == true) then isLoad = " |cFFE3ED29+|r" end	
				row.cells[1]:SetText(DateToString.." "..TimeToString)
				row.cells[2]:SetText(isLoad)
				if (AddEP ~= 0) then	
					--reaAction = "|r|cFF0AF53FEP |r"
					if (AddEP > 0) then reaAction = reaAction.."|r|cFF0AF53F+|r" else reaAction = "" end
					reaAction = reaAction.."|r|cFF0AF53F"..tostring(AddEP).."|r"					
					row.cells[3]:SetText(reaAction)
				else			
					row.cells[3]:SetText("")				
				end		
				if (AddGP ~= 0) then	
					--reaAction = "|cFFFF0000GP |r"
					reaAction = ""
					if (AddGP > 0) then reaAction = reaAction.."|cFFFF0000+|r" else reaAction = "" end
					reaAction = reaAction.."|cFFFF0000"..tostring(AddGP).."|r"					
					row.cells[4]:SetText(reaAction)
				else			
					row.cells[4]:SetText("")	
				end
				row.cells[5]:SetTextColor(MainColor.r, MainColor.g, MainColor.b)
				row.cells[5]:SetText(NameMain)	
				
				row.cells[6]:SetTextColor(ActiveCharacterColor.r, ActiveCharacterColor.g, ActiveCharacterColor.b)
				row.cells[6]:SetText(NameActiveCharacter)	
								
				row.cells[7]:SetText(tostring(Ep))
				row.cells[8]:SetText(tostring(Gp))
				row:Show()
			else
				row:Hide()
			end
		end
		FauxScrollFrame_Update(HF_EPGP_Log_ScrollFrame, numMembers, numDisplayedMembers, rowFrame.rowHeight, nil, nil, nil, nil, nil, nil, true)
		HF_Frame_EgGp_Log:SetScript("OnHide", 
			function(self) 
				self.name = nil 
				rowFrame.needUpdate = true 
				wipe(HF_Log)	
				local t = 1
				for list = #HF_Save_Data.EpGp.Log.History, 1, -1 do
					if variable == 0 then
						break
					end
					table.insert(HF_Log, HF_Save_Data.EpGp.Log.History[list])
				end	
				Update_Log_EPGP_HF() 
			end)
		rowFrame.needUpdate = nil
	end
	
	rowFrame:SetScript("OnUpdate", Update_Log_EPGP_HF)
	rowFrame:SetScript("OnShow", Update_Log_EPGP_HF)
	scrollBar:SetScript("OnVerticalScroll",	function(self, value) rowFrame.needUpdate = true FauxScrollFrame_OnVerticalScroll(self, value, rowFrame.rowHeight, Update_Log_EPGP_HF) end)
end

function HF_EPGP:Load_EpGp_Log_Itogo(HF_Frame_Main)
	HF_Frame_EgGp_Log_Itogo = hfFrame:Get_Frame("HF_Frame_EgGp_Log_Itogo", HF_Frame_Main, 750, 400, "Right")
	
	local today = {}
	today.Date = date("*t") -- returns { hour=1, min=31, sec=41, wday=1, day=14, month=6, year=2009, yday=165, isdst=true }
	if (today.ThisDay == nil) then today.ThisDay = {} end
	if (today.ThisDay.EP == nil) then today.ThisDay.EP = 0 end
	if (today.ThisDay.GP == nil) then today.ThisDay.GP = 0 end
	
	if (today.YesterDay == nil) then today.YesterDay = {} end
	if (today.YesterDay.EP == nil) then today.YesterDay.EP = 0 end
	if (today.YesterDay.GP == nil) then today.YesterDay.GP = 0 end
	
	if (today.All == nil) then today.All = {} end
	if (today.All.EP == nil) then today.All.EP = 0 end
	if (today.All.GP == nil) then today.All.GP = 0 end
	
	if (today.Minus == nil) then today.Minus = {} end
	if (today.Minus.EP == nil) then today.Minus.EP = 0 end
	if (today.Minus.GP == nil) then today.Minus.GP = 0 end
	
	for i=1,#HF_Save_Data.EpGp.Log.History do
		local info = { DateTime, Login, Ep, Gp, NameMain, MainClass, MainColor, NameActiveCharacter, ActiveCharacterClass, ActiveCharacterColor, 
		               NameRealm, AddEP, AddGP, DateToString, TimeToString }
		info.DateTime = HF_Save_Data.EpGp.Log.History[i].DateTime
		info.Login = HF_Save_Data.EpGp.Log.History[i].Login
		info.Ep = HF_Save_Data.EpGp.Log.History[i].Ep
		info.Gp = HF_Save_Data.EpGp.Log.History[i].Gp
		info.DateToString = HF_Save_Data.EpGp.Log.History[i].DateToString
		info.TimeToString = HF_Save_Data.EpGp.Log.History[i].TimeToString
		info.NameMain = HF_Save_Data.EpGp.Log.History[i].NameMain
		info.NameActiveCharacter = HF_Save_Data.EpGp.Log.History[i].NameActiveCharacter
		info.AddEP = HF_Save_Data.EpGp.Log.History[i].AddEP
		info.AddGP = HF_Save_Data.EpGp.Log.History[i].AddGP
		info.NameRealm = HF_Save_Data.EpGp.Log.History[i].NameRealm
		info.MainClass = HF_Save_Data.EpGp.Log.History[i].MainClass
		info.MainColor = HF_Save_Data.EpGp.Log.History[i].MainColor
		info.ActiveCharacterClass = HF_Save_Data.EpGp.Log.History[i].ActiveCharacterClass
		info.ActiveCharacterColor = HF_Save_Data.EpGp.Log.History[i].ActiveCharacterColor
		
		if (info.DateTime.yday == today.Date.yday and info.DateTime.year == today.Date.year) then			
			today.ThisDay.EP = today.ThisDay.EP + info.AddEP
			today.ThisDay.GP = today.ThisDay.GP + info.AddGP
		end
				
		if (info.DateTime.yday == today.Date.yday - 1 and info.DateTime.year == today.Date.year) then	
			today.YesterDay.EP = today.YesterDay.EP + info.AddEP
			today.YesterDay.GP = today.YesterDay.GP + info.AddGP
		end
		if(info.AddEP > 0) then today.All.EP = today.All.EP + info.AddEP end
		if(info.AddGP > 0) then today.All.GP = today.All.GP + info.AddGP end
		
		if(info.AddEP < 0) then today.Minus.EP = today.Minus.EP + info.AddEP end
		if(info.AddGP < 0) then today.Minus.GP = today.Minus.GP + info.AddGP end
	end
	
	if (actual_log_info == nil) then actual_log_info = {} end
	if (actual_log_info.YesterDay == nil) then actual_log_info.YesterDay = {} end
	if (actual_log_info.ThisDay == nil) then actual_log_info.ThisDay = {} end
	if (actual_log_info.All == nil) then actual_log_info.All = {} end
	if (actual_log_info.Minus == nil) then actual_log_info.Minus = {} end
	
	local controlsSize = {}
	controlsSize.startX = 20	
	controlsSize.leftControl = 130
	controlsSize.dateControl = 30
	
	
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, 'Вчера', font, "TOPLEFT", controlsSize.startX, -20)	
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, "EP ", font, "TOPLEFT", controlsSize.startX, -40)
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, "GP ", font, "TOPLEFT", controlsSize.startX, -60)
	actual_log_info.YesterDay.EP = hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, tostring(today.YesterDay.EP), font, "TOPLEFT", controlsSize.startX + controlsSize.dateControl, -40)
	actual_log_info.YesterDay.GP = hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, tostring(today.YesterDay.GP), font, "TOPLEFT", controlsSize.startX + controlsSize.dateControl, -60)
	
	controlsSize.startX = controlsSize.startX + controlsSize.leftControl
	
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, 'Сегодня', font, "TOPLEFT", controlsSize.startX, -20)	
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, "EP ", font, "TOPLEFT", controlsSize.startX, -40)
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, "GP ", font, "TOPLEFT", controlsSize.startX, -60)
	actual_log_info.ThisDay.EP = hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, tostring(today.ThisDay.EP), font, "TOPLEFT", controlsSize.startX + controlsSize.dateControl, -40)
	actual_log_info.ThisDay.GP = hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, tostring(today.ThisDay.GP), font, "TOPLEFT", controlsSize.startX + controlsSize.dateControl, -60)
	
	controlsSize.startX = controlsSize.startX + controlsSize.leftControl
	
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, 'За все время (+)', font, "TOPLEFT", controlsSize.startX, -20)	
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, "EP ", font, "TOPLEFT", controlsSize.startX, -40)
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, "GP ", font, "TOPLEFT", controlsSize.startX, -60)
	actual_log_info.All.EP = hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, tostring(today.All.EP), font, "TOPLEFT", controlsSize.startX + controlsSize.dateControl, -40)
	actual_log_info.All.GP = hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, tostring(today.All.GP), font, "TOPLEFT", controlsSize.startX + controlsSize.dateControl, -60)
	
	controlsSize.startX = controlsSize.startX + controlsSize.leftControl + 30
	
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, 'Потеряно (-15%)', font, "TOPLEFT", controlsSize.startX, -20)	
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, "EP ", font, "TOPLEFT", controlsSize.startX, -40)
	hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, "GP ", font, "TOPLEFT", controlsSize.startX, -60)
	actual_log_info.Minus.EP = hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, tostring(today.Minus.EP), font, "TOPLEFT", controlsSize.startX + controlsSize.dateControl, -40)
	actual_log_info.Minus.GP = hfFrame:Get_Text(HF_Frame_EgGp_Log_Itogo, 13, tostring(today.Minus.GP), font, "TOPLEFT", controlsSize.startX + controlsSize.dateControl, -60)
end

function HF_EPGP:EpGp_Log_Itogo()
	local today = {}
	today.Date = date("*t") -- returns { hour=1, min=31, sec=41, wday=1, day=14, month=6, year=2009, yday=165, isdst=true }
	if (today.ThisDay == nil) then today.ThisDay = {} end
	if (today.ThisDay.EP == nil) then today.ThisDay.EP = 0 end
	if (today.ThisDay.GP == nil) then today.ThisDay.GP = 0 end
	
	if (today.YesterDay == nil) then today.YesterDay = {} end
	if (today.YesterDay.EP == nil) then today.YesterDay.EP = 0 end
	if (today.YesterDay.GP == nil) then today.YesterDay.GP = 0 end
	
	if (today.All == nil) then today.All = {} end
	if (today.All.EP == nil) then today.All.EP = 0 end
	if (today.All.GP == nil) then today.All.GP = 0 end
	
	if (today.Minus == nil) then today.Minus = {} end
	if (today.Minus.EP == nil) then today.Minus.EP = 0 end
	if (today.Minus.GP == nil) then today.Minus.GP = 0 end
	
	for i=1,#HF_Save_Data.EpGp.Log.History do
		local info = { DateTime, Login, Ep, Gp, NameMain, MainClass, MainColor, NameActiveCharacter, ActiveCharacterClass, ActiveCharacterColor, 
		               NameRealm, AddEP, AddGP, DateToString, TimeToString }
		info.DateTime = HF_Save_Data.EpGp.Log.History[i].DateTime
		info.Login = HF_Save_Data.EpGp.Log.History[i].Login
		info.Ep = HF_Save_Data.EpGp.Log.History[i].Ep
		info.Gp = HF_Save_Data.EpGp.Log.History[i].Gp
		info.DateToString = HF_Save_Data.EpGp.Log.History[i].DateToString
		info.TimeToString = HF_Save_Data.EpGp.Log.History[i].TimeToString
		info.NameMain = HF_Save_Data.EpGp.Log.History[i].NameMain
		info.NameActiveCharacter = HF_Save_Data.EpGp.Log.History[i].NameActiveCharacter
		info.AddEP = HF_Save_Data.EpGp.Log.History[i].AddEP
		info.AddGP = HF_Save_Data.EpGp.Log.History[i].AddGP
		info.NameRealm = HF_Save_Data.EpGp.Log.History[i].NameRealm
		info.MainClass = HF_Save_Data.EpGp.Log.History[i].MainClass
		info.MainColor = HF_Save_Data.EpGp.Log.History[i].MainColor
		info.ActiveCharacterClass = HF_Save_Data.EpGp.Log.History[i].ActiveCharacterClass
		info.ActiveCharacterColor = HF_Save_Data.EpGp.Log.History[i].ActiveCharacterColor
		
		if (info.DateTime.yday == today.Date.yday and info.DateTime.year == today.Date.year) then			
			today.ThisDay.EP = today.ThisDay.EP + info.AddEP
			today.ThisDay.GP = today.ThisDay.GP + info.AddGP
		end
		
		if (
			(info.DateTime.yday == today.Date.yday - 1 and info.DateTime.year == today.Date.year)
			or
			(today.Date.yday == 1 and info.DateTime.year < today.Date.year)
			) then		
			today.YesterDay.EP = today.YesterDay.EP + info.AddEP
			today.YesterDay.GP = today.YesterDay.GP + info.AddGP
		end
		
		if(info.AddEP > 0) then today.All.EP = today.All.EP + info.AddEP end
		if(info.AddGP > 0) then today.All.GP = today.All.GP + info.AddGP end
		
		if(info.AddEP < 0) then today.Minus.EP = today.Minus.EP + info.AddEP end
		if(info.AddGP < 0) then today.Minus.GP = today.Minus.GP + info.AddGP end
	end
		
	actual_log_info.YesterDay.EP:SetText(tostring(today.YesterDay.EP))
	actual_log_info.YesterDay.GP:SetText(tostring(today.YesterDay.GP))
	
	actual_log_info.ThisDay.EP:SetText(tostring(today.ThisDay.EP))
	actual_log_info.ThisDay.GP:SetText(tostring(today.ThisDay.GP))
	
	actual_log_info.All.EP:SetText(tostring(today.All.EP))
	actual_log_info.All.GP:SetText(tostring(today.All.GP))	
	
	actual_log_info.Minus.EP:SetText(tostring(today.Minus.EP))
	actual_log_info.Minus.GP:SetText(tostring(today.Minus.GP))	
end

