﻿-- инициализация модуля как библиотеки
local lib = LibStub:NewLibrary("IconConfig", 1)
local hfFrame = LibStub:GetLibrary("LibFrame")
local AceGUI = LibStub("AceGUI-3.0")
local GS = LibStub:GetLibrary("LibGuildStorage")
local IG = LibStub:GetLibrary("InfoGuild")

local font = GameFontNormal:GetFont()
local HF_Frame_IconConfig, HF_Frame_IconConfig_Top, HF_Frame_IconConfig_Top_text
local adress_icons = "Interface\\AddOns\\\Heart_Of_Fire\\Texture\\Icon\\"
local iconOptions = {
	[1] = { i_max = adress_icons.."icon_minimap_01.tga", i_enable = adress_icons.."icon_minimap_01_e.blp", i_disable = adress_icons.."icon_minimap_01_d.blp", iconFrame = nil, x = 20, y = -20 },	
	[2] = { i_max = adress_icons.."icon_minimap_02.tga", i_enable = adress_icons.."icon_minimap_02_e.blp", i_disable = adress_icons.."icon_minimap_02_d.blp", iconFrame = nil, x = 20, y = -60 },
	[3] = { i_max = adress_icons.."icon_minimap_03.tga", i_enable = adress_icons.."icon_minimap_03_e.blp", i_disable = adress_icons.."icon_minimap_03_d.blp", iconFrame = nil, x = 20, y = -100 },
	[4] = { i_max = adress_icons.."icon_minimap_04.tga", i_enable = adress_icons.."icon_minimap_04_e.blp", i_disable = adress_icons.."icon_minimap_04_d.blp", iconFrame = nil, x = 20, y = -140 },
	[5] = { i_max = adress_icons.."icon_minimap_05.tga", i_enable = adress_icons.."icon_minimap_05_e.blp", i_disable = adress_icons.."icon_minimap_05_d.blp", iconFrame = nil, x = 20, y = -180 },
	[6] = { i_max = adress_icons.."icon_minimap_06.tga", i_enable = adress_icons.."icon_minimap_06_e.blp", i_disable = adress_icons.."icon_minimap_06_d.blp", iconFrame = nil, x = 20, y = -220 },
	[7] = { i_max = adress_icons.."icon_minimap_07.tga", i_enable = adress_icons.."icon_minimap_07_e.blp", i_disable = adress_icons.."icon_minimap_07_d.blp", iconFrame = nil, x = 20, y = -260 }
}

local MiniMapIcon = CreateFrame("Button", "HeartFireMinimap", Minimap)
MiniMapIcon:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight") 
MiniMapIcon:SetSize(32,32) 
MiniMapIcon:SetFrameStrata("MEDIUM")
MiniMapIcon:SetFrameLevel(8)
MiniMapIcon:SetPoint("CENTER", -15, -80)
MiniMapIcon:SetDontSavePosition(false)
MiniMapIcon:RegisterForDrag("LeftButton")
MiniMapIcon.icon = MiniMapIcon:CreateTexture(nil, "BACKGROUND")
MiniMapIcon.icon:SetSize(20,20)
MiniMapIcon.icon:SetPoint("CENTER", 0, 0)
MiniMapIcon.border = MiniMapIcon:CreateTexture(nil, "ARTWORK")
MiniMapIcon.border:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
MiniMapIcon.border:SetTexCoord(0,0.6,0,0.6)
MiniMapIcon.border:SetAllPoints()
MiniMapIcon:RegisterForClicks("anyUp")
MiniMapIcon:SetScript("OnEnter",function(self) 
	GameTooltip:SetOwner(self, "ANCHOR_LEFT") 
	GameTooltip:AddLine("Сердце огня") 
	GameTooltip:AddLine("ЛКМ - открыть окно настроек",1,1,1) 
	GameTooltip:Show() 
end)
MiniMapIcon:SetScript("OnLeave", function(self)    
	GameTooltip:Hide()
end)

local minimapShapes = {
	["ROUND"] = {true, true, true, true},
	["SQUARE"] = {false, false, false, false},
	["CORNER-TOPLEFT"] = {false, false, false, true},
	["CORNER-TOPRIGHT"] = {false, false, true, false},
	["CORNER-BOTTOMLEFT"] = {false, true, false, false},
	["CORNER-BOTTOMRIGHT"] = {true, false, false, false},
	["SIDE-LEFT"] = {false, true, false, true},
	["SIDE-RIGHT"] = {true, false, true, false},
	["SIDE-TOP"] = {false, false, true, true},
	["SIDE-BOTTOM"] = {true, true, false, false},
	["TRICORNER-TOPLEFT"] = {false, true, true, true},
	["TRICORNER-TOPRIGHT"] = {true, false, true, true},
	["TRICORNER-BOTTOMLEFT"] = {true, true, false, true},
	["TRICORNER-BOTTOMRIGHT"] = {true, true, true, false},
}

local IconMiniMapLeft, IconMiniMapTop

local function IconMoveButton(self)
	if self.dragMode == "free" then
		local centerX, centerY = Minimap:GetCenter()
		local x, y = GetCursorPosition()
		x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
		self:ClearAllPoints()
		self:SetPoint("CENTER", x, y)
		IconMiniMapLeft = x
		IconMiniMapTop = y
	else
		local mx, my = Minimap:GetCenter()
		local px, py = GetCursorPosition()
		local scale = Minimap:GetEffectiveScale()
		px, py = px / scale, py / scale
		
		local angle = math.atan2(py - my, px - mx)
		local x, y, q = math.cos(angle), math.sin(angle), 1
		if x < 0 then q = q + 1 end
		if y > 0 then q = q + 2 end
		local minimapShape = GetMinimapShape and GetMinimapShape() or "ROUND"
		local quadTable = minimapShapes[minimapShape]
		if quadTable[q] then
			x, y = x*80, y*80
		else
			local diagRadius = 103.13708498985 --math.sqrt(2*(80)^2)-10
			x = math.max(-80, math.min(x*diagRadius, 80))
			y = math.max(-80, math.min(y*diagRadius, 80))
		end
		self:ClearAllPoints()
		self:SetPoint("CENTER", Minimap, "CENTER", x, y)
		IconMiniMapLeft = x
		IconMiniMapTop = y
	end
end

MiniMapIcon:SetScript("OnDragStart", function(self)
	self:LockHighlight()
	self:SetScript("OnUpdate", IconMoveButton)
	self.isMoving = true
	GameTooltip:Hide()
end)
MiniMapIcon:SetScript("OnDragStop", function(self)
	self:UnlockHighlight()
	self:SetScript("OnUpdate", nil)
	self.isMoving = false
	HF_Save_Data.MiniMap.IconMiniMapLeft = IconMiniMapLeft
	HF_Save_Data.MiniMap.IconMiniMapTop = IconMiniMapTop	
end)

local function MiniMapIconOnClick(self, button)
	if button == "LeftButton" then
		HeartFire:ConfigOpen()
	end
end

MiniMapIcon:SetScript("OnMouseUp", MiniMapIconOnClick)

function lib:Instal()
	if (HF_Save_Data.MiniMap == nil) then HF_Save_Data.MiniMap = {} end
	if (HF_Save_Data.MiniMap.idIcon == nil) then HF_Save_Data.MiniMap.idIcon = 1 end
	if (HF_Save_Data.MiniMap.IconMiniMapLeft == nil) then HF_Save_Data.MiniMap.IconMiniMapLeft = -15 end
	if (HF_Save_Data.MiniMap.IconMiniMapTop == nil) then HF_Save_Data.MiniMap.IconMiniMapTop = -80 end
			
	MiniMapIcon:ClearAllPoints()
	MiniMapIcon:SetPoint("CENTER", HF_Save_Data.MiniMap.IconMiniMapLeft, HF_Save_Data.MiniMap.IconMiniMapTop)	

	if (HF_Save_Data.MiniMap.Enable == nil) then HF_Save_Data.MiniMap.Enable = true end
end

function lib:Loading(HF_Frame_Main)
	lib:Instal()
	lib:Load_Icon_Config(HF_Frame_Main)
	lib:Set_Icon()
end

function lib:GetIcon_Max(number)
	return iconOptions[number].i_max
end

function lib:GetIcon_Enable(number)
	return iconOptions[number].i_enable
end

function lib:GetIcon_Disable(number)
	return iconOptions[number].i_disable
end

function lib:Show()
	HF_Frame_IconConfig:Show()
	HF_Frame_IconConfig_Top:Show()
end

function lib:Hide()
	HF_Frame_IconConfig:Hide()
	HF_Frame_IconConfig_Top:Hide()
end

function lib:Text_01()
	return "Настройки иконки"
end

function lib:CreateFrameIcon(number, frame, adress, x, y, sizeX, sizeY)
	local crMapBackground = CreateFrame("Button", "crMapBackground"..tostring(number), frame)
	crMapBackground:SetNormalTexture(adress)
	crMapBackground:SetPoint("TOPLEFT", x, y)
	crMapBackground:SetSize(sizeX, sizeY)
	crMapBackground:SetScript("OnClick", function() HF_Save_Data.MiniMap.idIcon = number lib:Set_Icon() end)	
end

function lib:CreateIcon(frame, number, x, y)
	iconOptions[number].iconFrame = CreateFrame("CheckButton", "cbSer"..tostring(number), frame, "UIRadioButtonTemplate")
	iconOptions[number].iconFrame:SetPoint("TOPLEFT", x, y)
	iconOptions[number].iconFrame:SetScript("OnClick", function() HF_Save_Data.MiniMap.idIcon = number lib:Set_Icon() end)	
	if (HF_Save_Data.MiniMap.idIcon == number) then
		iconOptions[number].iconFrame:SetChecked(true)
	else
		iconOptions[number].iconFrame:SetChecked(false)
	end
	
	lib:CreateFrameIcon(number, iconOptions[number].iconFrame, lib:GetIcon_Max(number), 30, 5, 32, 32)
	lib:CreateFrameIcon(number, iconOptions[number].iconFrame, lib:GetIcon_Enable(number), 70, 0 , 20, 20)
	lib:CreateFrameIcon(number, iconOptions[number].iconFrame, lib:GetIcon_Disable(number), 100, 0 , 20, 20)
end

function lib:DeChecked(number)
	for i=1,#iconOptions do
		if (i ~= number) then
			iconOptions[i].iconFrame:SetChecked(false)
		end
	end
end

function lib:SetIconMinimap(number)
	iconOptions[number].iconFrame:SetChecked(true)
	if (HF_Save_Data.Addon_work == true) then
		MiniMapIcon.icon:SetTexture(lib:GetIcon_Enable(number))
	else
		MiniMapIcon.icon:SetTexture(lib:GetIcon_Disable(number))
	end	
end

function lib:Set_Icon()
	lib:DeChecked(tonumber(HF_Save_Data.MiniMap.idIcon))
	lib:SetIconMinimap(tonumber(HF_Save_Data.MiniMap.idIcon))
end

function lib:EnableMiniMap(button)	
	if (HF_Save_Data.MiniMap.Enable == true) then
		button:SetChecked(true)
		MiniMapIcon:Show()
	else
		button:SetChecked(false)
		MiniMapIcon:Hide()
	end
end

function lib:Load_Icon_Config(HF_Frame_Main)
	HF_Frame_IconConfig = hfFrame:Get_Frame("HF_Frame_IconConfig", HF_Frame_Main, 750, 400, "Right")
	
	HF_Frame_IconConfig_Top = hfFrame:Get_Frame("HF_Frame_IconConfig_Top", HF_Frame_Main, 750, 30, "TOPRIGHT")
	HF_Frame_IconConfig_Top_text = hfFrame:Get_Text(HF_Frame_IconConfig_Top, 13, lib:Text_01(), font, "TOPLEFT", 20, -10)	
				
	for i=1,#iconOptions do
		lib:CreateIcon(HF_Frame_IconConfig, i, iconOptions[i].x, iconOptions[i].y)
	end
	
	local btEnambleIcon = CreateFrame("CheckButton", "cbEnableAddon", HF_Frame_IconConfig, "ChatConfigCheckButtonTemplate")
	btEnambleIcon:SetPoint("TOPLEFT", 20, -370)
	btEnambleIcon:SetScript("OnClick", function() HF_Save_Data.MiniMap.Enable = btEnambleIcon:GetChecked() lib:EnableMiniMap(btEnambleIcon) end)	
	btEnambleIcon:SetChecked(HF_Save_Data.MiniMap.Enable)
	lib:EnableMiniMap(btEnambleIcon)
	
	local tcbEnable = hfFrame:Get_Text(btEnambleIcon, 13, "Отображать иконку у миникарты", font, "TOPLEFT", 30, -5)	
end