﻿-- инициализация модуля как библиотеки
local lib = LibStub:NewLibrary("InfoGuild", 1)
local hfFrame = LibStub:GetLibrary("LibFrame")
local AceGUI = LibStub("AceGUI-3.0")
local GS = LibStub:GetLibrary("LibGuildStorage")

local HF_Frame_InfoAddon_Top, HF_Frame_InfoAddon_Down
local HF_Frame_InfoAddon_text
local HF_Frame_InfoAddon, HF_Frame_Member, HF_Frame_Alt
local MainImageGuild, tGuildName, tGuildRankName, tMOTDinfo, tInfoText

local HF_selected = {}
HF_selected._count = 0
local HF_ourRealmName = string.gsub(GetRealmName(), "%s+", "") 

local sort_order = "NAME"
local standings = {}

local font = GameFontNormal:GetFont()
local infoAddonText = {}

local Member_name = {}
local selected = {}
local Members = {}
local frame_info_member = {}

function lib:ComparatorWrapper(f)
	return function(a, b)
		local a_selected = HF_selected[a]
		local b_selected = HF_selected[b]

		if a_selected ~= b_selected then
			return not b_selected
		end

		return f(a, b)
	end
end

local Member_comparators = {
	LVL = function(a, b)
		return GS:GetLevel(a) < GS:GetLevel(b)
	end,
	NAME = function(a, b)
		return a < b
	end,
	ZONE = function(a, b)
		return lib:GetZone(a) < lib:GetZone(b)
	end,
	PUBNOTE = function(a, b)
		return lib:GetPubNote(a) < lib:GetPubNote(b)
	end,
	NOTE = function(a, b)
		return lib:GetNote(a) < lib:GetNote(b)
	end,
	ACHIVEMENTPOINTS = function(a, b)
		return GS:GetAchievementPoints(a) < GS:GetAchievementPoints(b)
	end
}

for k,f in pairs(Member_comparators) do
	Member_comparators[k] = lib:ComparatorWrapper(f)
end

function lib:GetZone(name)
	local zone = GS:GetZone(name)
	if zone then return zone else return "" end
end

function lib:GetPubNote(name)
	local pNote = GS:GetPubNote(name)
	if pNote then return pNote else return "" end
end

function lib:GetNote(name)
	local note = GS:GetNote(name)
	if note then return note else return "" end
end

function lib:Instaling(HF_Frame_Main, HeartFireConfig, HeartFire)
	infoAddonText = { tGuildName, tGuildRankName, tMOTDinfo, tInfoText }
	
	if (HF_Save_Data.Guild == nil) then HF_Save_Data.Guild = {} end
	if (HF_Save_Data.Guild.Member == nil) then HF_Save_Data.Guild.Member = {} end
	if (HF_Save_Data.Guild.Member.All == nil) then HF_Save_Data.Guild.Member.All = 1 end
	if (HF_Save_Data.Guild.Member.Color == nil) then HF_Save_Data.Guild.Member.Color = 0 end
	if (HF_Save_Data.MiniMap == nil) then HF_Save_Data.MiniMap = {} end
		
	local guildName, guildRankName, guildRankIndex = GetGuildInfo("player")
	if (guildName == nil) then guildName = "" end
	if (guildRankName == nil) then guildRankName = "" end
	if (guildRankIndex == nil) then guildRankIndex = "" end
	infoAddonText.tGuildName = "Гильдия |cff99ffff"..guildName.."|r"
	infoAddonText.tGuildRankName = "Звание |cff99ffff"..guildRankName.."|r"
	
	local GuildRosterMOTD, GuildInfoText = GetGuildRosterMOTD(), GetGuildInfoText()
	if (GuildRosterMOTD == nil) then GuildRosterMOTD = "" end
	if (GuildInfoText == nil) then GuildInfoText = "" end		
	infoAddonText.tMOTDinfo = "|cff99ffff"..GuildRosterMOTD.."|r"
	infoAddonText.tInfoText = "|cff99ffff"..GuildInfoText.."|r"
		
	HF_Frame_InfoAddon_Down = hfFrame:Get_Frame("HF_Frame_InfoAddon_Down", HF_Frame_Main, 750, 30, "BOTTOMRIGHT")
	
	HF_Frame_InfoAddon_Top = hfFrame:Get_Frame("HF_Frame_InfoAddon_Top", HF_Frame_Main, 750, 30, "TOPRIGHT")
	HF_Frame_InfoAddon_text = hfFrame:Get_Text(HF_Frame_InfoAddon_Top, 13, lib:Text_01(), font, "TOPLEFT", 20, -10)	
	
	local hf = lib:Load_InfoAddon(HF_Frame_Main, HeartFireConfig)
	lib:Load_Guild_Member(HF_Frame_Main, HeartFire)
	GS.RegisterCallback(self, "GuildMemberChanged", Member_ParseGuildNote)
	
	lib:Load_Alt(HF_Frame_Main)
	
	local button = CreateFrame("Button", "btMainInfo_Guild", HF_Frame_InfoAddon_Down)
	button:SetPoint("TopLeft", HF_Frame_InfoAddon_Down, "TopLeft", 10, -3)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Основная информация")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", Main_info_Show)
	
	button = hfFrame:Get_Texture_Button(button)
	
	
	button = CreateFrame("Button", "btMainInfo_Guild_Member", HF_Frame_InfoAddon_Down)
	button:SetPoint("TopLeft", HF_Frame_InfoAddon_Down, "TopLeft", 170, -3)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Члены гильдии")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", Main_info_Member_Show)
	
	button = hfFrame:Get_Texture_Button(button)
	
	
	button = CreateFrame("Button", "btMainInfo_Guild_Alt", HF_Frame_InfoAddon_Down)
	button:SetPoint("TopLeft", HF_Frame_InfoAddon_Down, "TopLeft", 330, -3)
	button:SetWidth(150)
	button:SetHeight(21)
	
	button:SetText("Альты")
	button:SetNormalFontObject("GameFontNormalSmall")
	button:SetScript("OnMouseUp", Main_info_Alt_Show)
	
	button = hfFrame:Get_Texture_Button(button)
	
	return hf
end

function Member_ParseGuildNote(callback, level, name, className, class, zone, pubNote, note, achievementPoints, online)
	Member_name[name] = nil	
	Member_name[name] = name
		
	lib:DestroyStandings()
	lib:DestroyMembers()
	GS:SetOutsidersEnabled(true)		
end

function lib:Show()
	Main_info_Show()
end

function lib:Hide()
	Main_info_Hide()
end

function Main_info_Show()
	lib:Update_Info()
	HF_Frame_InfoAddon:Show()
	HF_Frame_InfoAddon_Down:Show()
	HF_Frame_InfoAddon_Top:Show()
	HF_Frame_Member:Hide()
	HF_Frame_Alt:Hide()
	
	HF_Frame_InfoAddon_text:SetText(lib:Text_01())
end

function Main_info_Hide()
	HF_Frame_InfoAddon:Hide()
	HF_Frame_InfoAddon_Down:Hide()
	HF_Frame_InfoAddon_Top:Hide()	
	HF_Frame_Member:Hide()
	HF_Frame_Alt:Hide()
end

function Main_info_Member_Show()
	HF_Frame_InfoAddon:Hide()
	HF_Frame_InfoAddon_Down:Show()
	HF_Frame_InfoAddon_Top:Show()
	HF_Frame_Alt:Hide()
	
	HF_Frame_Member:Show()
	
	HF_Frame_InfoAddon_text:SetText(lib:Text_02())
end

function Main_info_Member_Hide()
	HF_Frame_InfoAddon:Hide()
	HF_Frame_InfoAddon_Down:Hide()
	HF_Frame_InfoAddon_Top:Hide()
	HF_Frame_Member:Hide()
	HF_Frame_Alt:Hide()
end

function Main_info_Alt_Show()
	HF_Frame_InfoAddon:Hide()
	HF_Frame_InfoAddon_Down:Show()
	HF_Frame_InfoAddon_Top:Show()
	HF_Frame_Alt:Show()	
	HF_Frame_Member:Hide()
	
	HF_Frame_InfoAddon_text:SetText(lib:Text_03())
end

function Main_info_Alt_Hide()
	HF_Frame_InfoAddon:Hide()
	HF_Frame_InfoAddon_Down:Hide()
	HF_Frame_InfoAddon_Top:Hide()
	HF_Frame_Member:Hide()
	HF_Frame_Alt:Hide()
end

function lib:Load_InfoAddon(HF_Frame_Main, HeartFireConfig)
	HF_Frame_InfoAddon = hfFrame:Get_Frame("HF_Frame_InfoAddon", HF_Frame_Main, 750, 400, "Right")	
	
	secred01 = 0
	
	MainImageGuild = CreateFrame("Button", "btImage", HF_Frame_InfoAddon)
	MainImageGuild:SetPoint("TOPLEFT", HF_Frame_InfoAddon, "TOPLEFT", 10, -10)
	MainImageGuild:SetNormalTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\MainImageGuild.tga")
	MainImageGuild:SetSize(180, 385)
	MainImageGuild:SetScript("OnClick", function() GetSecret01() end)
	
	HeartFireConfig.cbEnable = CreateFrame("CheckButton", "cbEnableAddon", HF_Frame_InfoAddon, "ChatConfigCheckButtonTemplate")
	HeartFireConfig.cbEnable:SetPoint("TOPLEFT", 200, -10)
	HeartFireConfig.cbEnable:SetScript("OnClick", Enable_Addon)	
	HeartFireConfig.cbEnable:SetChecked(HF_Save_Data.Addon_work)
	
	local tcbEnable = hfFrame:Get_Text(HF_Frame_InfoAddon, 13, "Включить аддон", font, "TOPLEFT", 230, -15)		
	
	tGuildName = hfFrame:Get_Text(HF_Frame_InfoAddon, 13, infoAddonText.tGuildName, font, "TOPLEFT", 200, -40)
	tGuildRankName = hfFrame:Get_Text(HF_Frame_InfoAddon, 13, infoAddonText.tGuildRankName, font, "TOPLEFT", 202, -60)	-- 205 = костыль из-за букви "З"
	
	local tMOTDName = hfFrame:Get_Text(HF_Frame_InfoAddon, 13, "Сообщение дня", font, "TOPLEFT", 200, -80)	
	tMOTDinfo = hfFrame:Get_Text(HF_Frame_InfoAddon, 13, infoAddonText.tMOTDinfo, font, "TOPLEFT", 200, -100, 510, 40, "LEFT", "TOP")	
	
	local tInfoTextName = hfFrame:Get_Text(HF_Frame_InfoAddon, 13, "О гильдии", font, "TOPLEFT", 200, -160)		
	tInfoText = hfFrame:Get_Text(HF_Frame_InfoAddon, 13, infoAddonText.tInfoText, font, "TOPLEFT", 200, -180, 510, 220, "LEFT", "TOP")			
	
	HeartFireConfig.cbPosition = CreateFrame("CheckButton", "cbPosition_Addon", HF_Frame_InfoAddon, "ChatConfigCheckButtonTemplate")
	HeartFireConfig.cbPosition:SetPoint("TOPLEFT", 380, -10)
	HeartFireConfig.cbPosition:SetScript("OnClick", Position_Addon)	
	HeartFireConfig.cbPosition:SetChecked(HF_Save_Data.clearFramePosition)	
	
	local tbcPositionClear = hfFrame:Get_Text(HF_Frame_InfoAddon, 13, "Закрепить", font, "TOPLEFT", 410, -15)	
		
	return HeartFireConfig
end 

function lib:Load_Guild_Member(HF_Frame_Main, HeartFire)
	HF_Frame_Member = hfFrame:Get_Frame("HF_Frame_Member", HF_Frame_Main, 750, 400, "Right")	
	
	local tabl_member = CreateFrame("Frame", "HF_Frame_tabl_Member", HF_Frame_Member)
	tabl_member:SetPoint("TOPLEFT")
	tabl_member:SetPoint("TOPRIGHT")
	tabl_member:SetPoint("BOTTOM", HF_Frame_InfoAddon_Down, "TOP", 0, 30)
		
	hfFrame:CreateTable(tabl_member,
	{"лвл", "Имя", "зона", "заметка", "офф заметка", "очки достиж."},
	{0, 110, 162, 170, 160, 80},
	{"LEFT", "RIGHT", "RIGHT", "RIGHT", "RIGHT", "RIGHT"},
	27)
				
	local rowFrame = tabl_member.rowFrame
	rowFrame.needUpdate = true
	local scrollBar = CreateFrame("ScrollFrame", "HF_Member_ScrollFrame",
	rowFrame, "FauxScrollFrameTemplateLight")
	scrollBar:SetWidth(rowFrame:GetWidth())
	scrollBar:SetPoint("TOPRIGHT", rowFrame, "TOPRIGHT", 0, -8)
	scrollBar:SetPoint("BOTTOMRIGHT", 0, 8)
	
	tabl_member.headers[1]:SetScript("OnClick", function(self) lib:StandingsSort("LVL") end)
	tabl_member.headers[2]:SetScript("OnClick", function(self) lib:StandingsSort("NAME") end)
	tabl_member.headers[3]:SetScript("OnClick", function(self) lib:StandingsSort("ZONE") end)
	tabl_member.headers[4]:SetScript("OnClick", function(self) lib:StandingsSort("PUBNOTE") end)
	tabl_member.headers[5]:SetScript("OnClick", function(self) lib:StandingsSort("NOTE") end)
	tabl_member.headers[6]:SetScript("OnClick", function(self) lib:StandingsSort("ACHIVEMENTPOINTS") end)
		
	local function Update_Member_HF()
		if not rowFrame.needUpdate then return end		
		local fontHeight = 13 + 2
		local rowHeight = fontHeight + 4
		rowFrame.rowHeight = rowHeight
		local numRows = math.floor(rowFrame:GetHeight() / rowHeight)
	
		local offset = FauxScrollFrame_GetOffset(HF_Member_ScrollFrame)
		local numMembers = lib:GetNumMembers()
		local numDisplayedMembers = math.min(numRows, numMembers - offset)
		for i=1,#rowFrame.rows do
			local row = rowFrame.rows[i]
			local j = i + offset			
			if j <= numMembers then
				local isMember = lib:GetMember(j)
				row.name = isMember
				
				row:SetScript("OnEnter",
					function(self) -- всплывающее окно, при наведении на строку с данными, показывает информацию о мейнах и альтах
						GameTooltip_SetDefaultAnchor(GameTooltip, self)
						GameTooltip:AddLine("Информация".."\n")						
						GameTooltip:AddLine("|cFFFF8000Имя:|r "..Ambiguate(row.name, "short"), 1, 1, 1)	
						GameTooltip:AddLine("|cFFFF8000Класс:|r "..GS:GetClassName(row.name), 1, 1, 1)	
						GameTooltip:AddLine("|cFFFF8000Заметка:|r "..lib:GetPubNote(row.name), 1, 1, 1)			
						GameTooltip:AddLine("|cFFFF8000Офф аметка:|r "..lib:GetNote(row.name), 1, 1, 1)		
						GameTooltip:AddLine("|cFFFF8000Зона:|r "..lib:GetZone(row.name), 1, 1, 1)		
						if GS:GetOnline(row.name) then
							GameTooltip:AddLine("|cFF800080Онлайн|r", 1, 1, 1)	
						else
							GameTooltip:AddLine("|cFF808040Оффлайн|r", 1, 1, 1)	
						end
						
						GameTooltip:ClearAllPoints()
						GameTooltip:SetPoint("TOPLEFT", self, "TOPRIGHT")
						GameTooltip:Show()
					end)
				row:SetScript("OnLeave", function() GameTooltip:Hide() end)
								
				row.cells[1]:SetText(GS:GetLevel(row.name))
				local c = RAID_CLASS_COLORS[GS:GetClass(row.name)]
				row.cells[2]:SetTextColor(c.r, c.g, c.b)
				row.cells[2]:SetText(Ambiguate(row.name, "short"))
				row.cells[3]:SetText(lib:GetZone(row.name))
				row.cells[4]:SetText(lib:GetPubNote(row.name))
				row.cells[5]:SetText(lib:GetNote(row.name))
				row.cells[6]:SetText(GS:GetAchievementPoints(row.name))
				
				if HF_Save_Data.Guild.Member.Color == true and GS:GetOnline(row.name) == false then
					row.cells[1]:SetTextColor(0.5, 0.5, 0.5)
					row.cells[2]:SetTextColor(0.5, 0.5, 0.5)
					row.cells[3]:SetTextColor(0.5, 0.5, 0.5)
					row.cells[4]:SetTextColor(0.5, 0.5, 0.5)
					row.cells[5]:SetTextColor(0.5, 0.5, 0.5)
					row.cells[6]:SetTextColor(0.5, 0.5, 0.5)
				else
					row.cells[1]:SetTextColor(1, 1, 1, 1)
					row.cells[2]:SetTextColor(c.r, c.g, c.b)
					row.cells[3]:SetTextColor(1, 1, 1, 1)
					row.cells[4]:SetTextColor(1, 1, 1, 1)
					row.cells[5]:SetTextColor(1, 1, 1, 1)
					row.cells[6]:SetTextColor(1, 1, 1, 1)
				end
				
				row:Show()
			else
				row:Hide()
			end
		end
		FauxScrollFrame_Update(HF_Member_ScrollFrame, numMembers, numDisplayedMembers, rowFrame.rowHeight, nil, nil, nil, nil, nil, nil, true)
		HF_Frame_Member:SetScript("OnHide", 
			function(self) 
				self.name = nil 
				rowFrame.needUpdate = true 
				Update_Member_HF() 
				lib:DestroyStandings()
				lib:RefreshStandings(sort_order)
				local fontHeight = 13 + 2
				local rowHeight = fontHeight + 4
				rowFrame.rowHeight = rowHeight
				local numRows = math.floor(rowFrame:GetHeight() / rowHeight)
			
				local numMembers = lib:GetNumMembers()
				FauxScrollFrame_Update(HF_Member_ScrollFrame, 0, 0, rowFrame.rowHeight, nil, nil, nil, nil, nil, nil, true)
			end)
		rowFrame.needUpdate = nil
	end
	
	
	local chButton_cg_member_all = CreateFrame("CheckButton", "cg_member_all", HF_Frame_Member, "ChatConfigCheckButtonTemplate")
	chButton_cg_member_all:SetPoint("TOPLEFT", 20, -370)
	chButton_cg_member_all:SetScript("OnClick", 
		function() 
			HF_Save_Data.Guild.Member.All = chButton_cg_member_all:GetChecked() 
			rowFrame.needUpdate = true 
			Update_Member_HF() 
			lib:DestroyStandings()
			lib:RefreshStandings(sort_order)
			FauxScrollFrame_Update(HF_Member_ScrollFrame, 0, 0, rowFrame.rowHeight, nil, nil, nil, nil, nil, nil, true)
		end)	
	chButton_cg_member_all:SetChecked(HF_Save_Data.Guild.Member.All)
	hfFrame:Get_Text(HF_Frame_Member, 13, "Показывать оффлайн", font, "TOPLEFT", 50, -375)	
		
	local chButton_cg_member_color = CreateFrame("CheckButton", "cg_member_color", HF_Frame_Member, "ChatConfigCheckButtonTemplate")
	chButton_cg_member_color:SetPoint("TOPLEFT", 200, -370)
	chButton_cg_member_color:SetScript("OnClick", 
		function() 
			HF_Save_Data.Guild.Member.Color = chButton_cg_member_color:GetChecked() 
			rowFrame.needUpdate = true 
			Update_Member_HF() 
		end)	
	chButton_cg_member_color:SetChecked(HF_Save_Data.Guild.Member.Color)
	hfFrame:Get_Text(HF_Frame_Member, 13, "Затемнить оффлайн", font, "TOPLEFT", 230, -375)	
	
	
	rowFrame:SetScript("OnUpdate", Update_Member_HF)
	HeartFire.RegisterCallback(rowFrame, "Member_Changer_sort", function() rowFrame.needUpdate = true end)
	rowFrame:SetScript("OnShow", 
		function(self) 
			self.name = nil 
			rowFrame.needUpdate = true 
			Update_Member_HF() 
			lib:DestroyStandings()
			lib:RefreshStandings(sort_order)
			local fontHeight = 13 + 2
			local rowHeight = fontHeight + 4
			rowFrame.rowHeight = rowHeight
			local numRows = math.floor(rowFrame:GetHeight() / rowHeight)
		
			local numMembers = lib:GetNumMembers()
			FauxScrollFrame_Update(HF_Member_ScrollFrame, numMembers, 0, rowFrame.rowHeight, nil, nil, nil, nil, nil, nil, true)
		end)
	scrollBar:SetScript("OnVerticalScroll",	
		function(self, value) 
		rowFrame.needUpdate = true 
		FauxScrollFrame_OnVerticalScroll(self, value, rowFrame.rowHeight, Update_Member_HF) 
	end)
end

function lib:Select_Alt(name)
	selected[name] = true
	for n in pairs(Member_name) do
		if (n ~= name) then 
			selected[n] = false
		end
	end
							
	local c = RAID_CLASS_COLORS[GS:GetClass(name)]
	frame_info_member.text_Main:SetTextColor(c.r, c.g, c.b)
	frame_info_member.text_Main:SetText(Ambiguate(name, "short"))
	frame_info_member.class:SetText("|cFFFF8000Класс:|r "..GS:GetClassName(name))
	frame_info_member.pubNote:SetText("|cFFFF8000Заметка:|r "..GS:GetPubNote(name))
	frame_info_member.note:SetText("|cFFFF8000Офф заметка:|r "..GS:GetNote(name))
	frame_info_member.zone:SetText("|cFFFF8000Зона:|r "..GS:GetZone(name))
	frame_info_member.rank:SetText("|cFFFF8000Ранг:|r "..GS:GetRank(name))
	frame_info_member.level:SetText("|cFFFF8000Уровень:|r "..GS:GetLevel(name))
	frame_info_member.aPoint:SetText("|cFFFF8000Очки достижения:|r "..GS:GetAchievementPoints(name))
	
	local isMain = 1
	local nameMain = Ambiguate(name, "short")
	local newNameMain = nameMain
	local countMain = 0
	local alt = {}
	
	for n in pairs(Member_name) do
		if (string.match(lib:GetPubNote(n), nameMain) or string.match(lib:GetNote(n), nameMain)) and selected[n] == false then	
			table.insert(alt, n)
		end
		if (string.match(lib:GetPubNote(name), Ambiguate(n, "short")) or string.match(lib:GetNote(name), Ambiguate(n, "short"))) and selected[n] == false then	
			isMain = 0
			newNameMain = Ambiguate(n, "short")
			countMain = countMain + 1
		end
	end
	
	nameMain = newNameMain
	if (nameMain ~= Ambiguate(name, "short")) then
		wipe(alt)
		for n in pairs(Member_name) do
			if (string.match(lib:GetPubNote(n), nameMain) or string.match(lib:GetNote(n), nameMain)) and selected[n] == false then
				table.insert(alt, n)
			end
		end
		table.insert(alt, Ambiguate(name, "short"))
	end
	
	table.sort(alt, Member_comparators["NAME"])
	nameMain = "|c"..RAID_CLASS_COLORS[GS:GetClass(nameMain.."-"..HF_ourRealmName)].colorStr..nameMain.."|r ("..GS:GetLevel(nameMain.."-"..HF_ourRealmName)..")"
	
	for i=1,#alt do
		local fullName = Ambiguate(alt[i], "short").."-"..HF_ourRealmName
		local color = RAID_CLASS_COLORS[GS:GetClass(fullName)]
		alt[i] = "|c"..color.colorStr..Ambiguate(alt[i], "short").."|r ("..GS:GetLevel(fullName)..")"
	end
	
	local typeCharacter = "Основной"
	if (isMain ~= 1) then typeCharacter = "Альт" end
	frame_info_member.typeCharacter:SetText("|cFFFF8000Тип персонажа:|r "..typeCharacter)
	frame_info_member.nameMain:SetText("|cFFFF8000Имя основного персонажа:|r "..nameMain)
	if #alt > 0 then
		frame_info_member.listAlt:SetText("|cFFFF8000Список альтов: ("..tostring(#alt)..")|r ")
		for i=1,#alt do
			frame_info_member.listAlt:SetText(frame_info_member.listAlt:GetText()..", "..alt[i])
		end
	else
		frame_info_member.listAlt:SetText("|cFFFF8000Альты не найдены|r ")
	end
end

function lib:De_Select_Alt(name)
	selected[name] = false
	frame_info_member.text_Main:SetText("")
	frame_info_member.class:SetText("")
	frame_info_member.pubNote:SetText("")
	frame_info_member.note:SetText("")
	frame_info_member.zone:SetText("")
	frame_info_member.rank:SetText("")
	frame_info_member.level:SetText("")
	frame_info_member.aPoint:SetText("")
	frame_info_member.typeCharacter:SetText("")
	frame_info_member.nameMain:SetText("")
	frame_info_member.listAlt:SetText("")
end


function lib:Load_Alt(HF_Frame_Main)
	HF_Frame_Alt = hfFrame:Get_Frame("HF_Frame_Alt", HF_Frame_Main, 750, 400, "Right")	
	
	local tabl_member = CreateFrame("Frame", "HF_Frame_tabl_Alt", HF_Frame_Alt)
	tabl_member:SetPoint("TOPLEFT", 0, -120)
	tabl_member:SetPoint("TOPRIGHT")
	tabl_member:SetPoint("BOTTOM", HF_Frame_InfoAddon_Down, "TOP", 0, 0)
		
	hfFrame:CreateTable(tabl_member, {"Имя"}, {200}, {"LEFT"}, 550)
				
	local rowFrame = tabl_member.rowFrame
	rowFrame.needUpdate = true
	local scrollBar = CreateFrame("ScrollFrame", "HF_Alt_ScrollFrame", rowFrame, "FauxScrollFrameTemplateLight")
	scrollBar:SetWidth(rowFrame:GetWidth())
	scrollBar:SetPoint("TOPRIGHT", rowFrame, "TOPRIGHT", 0, -5)
	scrollBar:SetPoint("BOTTOMRIGHT", 0, 8)
			
	local function Update_Alt_HF()
		if not rowFrame.needUpdate then return end		
		local fontHeight = 13 + 2
		local rowHeight = fontHeight + 4
		rowFrame.rowHeight = rowHeight
		local numRows = math.floor(rowFrame:GetHeight() / rowHeight)
	
		local offset = FauxScrollFrame_GetOffset(HF_Alt_ScrollFrame)
		local numMembers = lib:GetNumMembers_Alt()
		local numDisplayedMembers = math.min(numRows, numMembers - offset)
		for i=1,#rowFrame.rows do
			local row = rowFrame.rows[i]
			local j = i + offset			
			if j <= numMembers then
				local isMember = lib:GetMember_Alt(j)
				row.name = isMember
				
				row:RegisterForClicks("LeftButtonDown")
				row:SetScript("OnClick",
					function(self, value)					
						if selected[self.name] then
							lib:De_Select_Alt(self.name)
						else
							lib:Select_Alt(self.name)
						end
					end)
								
				local c = RAID_CLASS_COLORS[GS:GetClass(row.name)]
				row.cells[1]:SetTextColor(c.r, c.g, c.b)
				row.cells[1]:SetText(Ambiguate(row.name, "short"))
				row:Show()
			else
				row:Hide()
			end
		end
		FauxScrollFrame_Update(HF_Alt_ScrollFrame, numMembers, numDisplayedMembers, rowFrame.rowHeight, nil, nil, nil, nil, nil, nil, true)
		HF_Frame_Alt:SetScript("OnHide", 
			function(self) 
				self.name = nil 
				rowFrame.needUpdate = true 
				Update_Alt_HF() 
			end)
		rowFrame.needUpdate = nil
	end
	
	rowFrame:SetScript("OnUpdate", Update_Alt_HF)
	HeartFire.RegisterCallback(rowFrame, "Member_Changer_sort", function() rowFrame.needUpdate = true end)
	rowFrame:SetScript("OnShow", 
		function(self) 
			self.name = nil 
			rowFrame.needUpdate = true 
			Update_Alt_HF() 
		end)
	scrollBar:SetScript("OnVerticalScroll",	
		function(self, value) 
		rowFrame.needUpdate = true 
		FauxScrollFrame_OnVerticalScroll(self, value, rowFrame.rowHeight, Update_Alt_HF) 
	end)	
	
	local chButton_alt_name = CreateFrame("EditBox", "chButton_alt_name", HF_Frame_Alt, "InputBoxTemplate")
	chButton_alt_name:SetPoint("TOPLEFT", 80, -20)
	chButton_alt_name:SetWidth(140)
	chButton_alt_name:SetHeight(21)
	chButton_alt_name:SetAutoFocus(false)
		
	local chButton_alt_note = CreateFrame("EditBox", "chButton_alt_note", HF_Frame_Alt, "InputBoxTemplate")
	chButton_alt_note:SetPoint("TOPLEFT", 80, -50)
	chButton_alt_note:SetWidth(140)
	chButton_alt_note:SetHeight(21)
	chButton_alt_note:SetAutoFocus(false)
		
	local chButton_alt_noteOff = CreateFrame("EditBox", "chButton_alt_noteOff", HF_Frame_Alt, "InputBoxTemplate")
	chButton_alt_noteOff:SetPoint("TOPLEFT", 80, -80)
	chButton_alt_noteOff:SetWidth(140)
	chButton_alt_noteOff:SetHeight(21)
	chButton_alt_noteOff:SetAutoFocus(false)
	
	local function SearchMember()
		rowFrame.needUpdate = true 
		Update_Alt_HF() 
		lib:DestroyMembers()
		lib:RefreshMembers(chButton_alt_name:GetText(), chButton_alt_note:GetText(), chButton_alt_noteOff:GetText())
		FauxScrollFrame_Update(HF_Alt_ScrollFrame, 0, 0, rowFrame.rowHeight, nil, nil, nil, nil, nil, nil, true)
	end
	
	chButton_alt_name:SetScript("OnTextChanged", function() SearchMember() end)		
	chButton_alt_note:SetScript("OnTextChanged", function() SearchMember() end)			
	chButton_alt_noteOff:SetScript("OnTextChanged", function() SearchMember() end)	
		
	hfFrame:Get_Text(HF_Frame_Alt, 13, "Поиск персонажа по:", font, "TOPLEFT", 50, -7)
	hfFrame:Get_Text(HF_Frame_Alt, 13, "Имя", font, "TOPLEFT", 5, -27)
	hfFrame:Get_Text(HF_Frame_Alt, 13, "Зам.", font, "TOPLEFT", 5, -57)
	hfFrame:Get_Text(HF_Frame_Alt, 13, "Зам. офф", font, "TOPLEFT", 5, -87)
	
	frame_info_member.text_Main = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 330, -7)	
	frame_info_member.class = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 280, -27)	
	frame_info_member.pubNote = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 280, -47)	
	frame_info_member.note = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 280, -67)	
	frame_info_member.zone = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 280, -87)	
	frame_info_member.rank = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 280, -107)	
	frame_info_member.level = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 280, -127)	
	frame_info_member.aPoint = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 280, -147)	
	frame_info_member.typeCharacter = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 280, -187)
	frame_info_member.nameMain = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 280, -207)
	frame_info_member.listAlt = hfFrame:Get_Text(HF_Frame_Alt, 13, "", font, "TOPLEFT", 280, -227, 450, 220, "LEFT", "TOP")
end 

function lib:GetMember(i)
	if #standings == 0 then
		RefreshStandings(sort_order)
	end

	return standings[i]
end

function lib:GetNumMembers()	
	if #standings == 0 then
		lib:RefreshStandings(sort_order)
	end

	return #standings
end

function lib:RefreshStandings(order)
	if HF_Save_Data.Guild.Member.All == true then
		for n in pairs(Member_name) do
			table.insert(standings, n)
		end
	else
		for n in pairs(Member_name) do
			if GS:GetOnline(n) then
				table.insert(standings, n)
			end
		end
	end
	
	table.sort(standings, Member_comparators[order])
end

function lib:StandingsSort(order)
	if not order then
		return sort_order
	end

	assert(Member_comparators[order], "Unknown sort order")

	sort_order = order
	lib:DestroyStandings()
end

function lib:DestroyStandings()
	wipe(standings)
	HF_CallbackHandler:Fire("Member_Changer_sort")
end

function lib:GetMember_Alt(i)
	return Members[i]
end

function lib:GetNumMembers_Alt()		
	return #Members
end

function lib:RefreshMembers(name, pubNote, note)
	if ((name == "" or name == nil) and (pubNote == "" or pubNote == nil) and (note == "" or note == nil)) then
		for n in pairs(Member_name) do
			table.insert(Members, n)
		end
	else
		for n in pairs(Member_name) do
			if 
				(
					(string.match(n, name) or name == "" or name == nil ) 
					and
					(string.match(lib:GetPubNote(n), pubNote) or pubNote == "" or pubNote == nil ) 
					and
					(string.match(lib:GetNote(n), note) or note == "" or note == nil ) 
				)					
					then
						table.insert(Members, n)
			end
		end
	end
	
	table.sort(Members, Member_comparators["NAME"])
end

function lib:DestroyMembers()
	wipe(Members)
	HF_CallbackHandler:Fire("Member_Changer_sort")
end

function lib:Update_Info()
	local guildName, guildRankName, guildRankIndex = GetGuildInfo("player")
	infoAddonText.tGuildName = "Гильдия |cff99ffff"..guildName.."|r"
	tGuildName:SetText(infoAddonText.tGuildName)
	
	infoAddonText.tGuildRankName = "Звание |cff99ffff"..guildRankName.."|r"
	tGuildRankName:SetText(infoAddonText.tGuildRankName)
	
	infoAddonText.tMOTDinfo = "|cff99ffff"..GetGuildRosterMOTD().."|r"
	tMOTDinfo:SetText(infoAddonText.tMOTDinfo)
	
	infoAddonText.tInfoText = "|cff99ffff"..GetGuildInfoText().."|r"
	tInfoText:SetText(infoAddonText.tInfoText)
end

function GetSecret01()
	if (secred01 < 10) then		
		secred01 = secred01 + 1
		MainImageGuild:SetNormalTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\MainImageGuild.tga")
	else
		secred01 = 0
		MainImageGuild:SetNormalTexture("Interface\\AddOns\\\Heart_Of_Fire\\Texture\\MainImageGuild_secret.tga")
	end
end

function lib:Clear_Secret01()
	secred01 = 0
	GetSecret01()
end

function lib:Text_01()
	return "О гильдии".."  —  |cFF0EE109Основная информация|r"
end

function lib:Text_02()
	return "О гильдии".."  —  |cFF0EE109Члены гильдии|r"
end

function lib:Text_03()
	return "О гильдии".."  —  |cFF0EE109Альты|r"
end